/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeDistAng()
{
	var dah =

'<center><b>Measuring Distances and Angles</b></center> \n\
\
<br> \n\
\
<img src="distance.gif" align="right" border=1> \n\
\
To measure the <b>distance</b> between two atoms, double click on the \n\
first atom. Now, as you touch other atoms, the distances will be shown \n\
on a red line connecting the atoms. \n\
\
<b>Double click</b> on a second atom to fix the distance report. \n\
\
<br><br> \n\
\
If you wish to <b>cancel</b> without fixing a distance report, \n\
simply move the mouse outside of the Jmol rectangle. If you wish to \n\
<b>erase one</b> already fixed report, double click on each \n\
of those two atoms again. Or you can \n\
<center><br> \n\
<a href="javascript: hideMonitors()"><b>Erase All \
Distances And Angles.</b></a>  \n\
</center>\
\
<br clear="right">\
\
<img src="angle.gif" align="left" border=1 hspace="4">\
\
To measure an <b>angle</b>, double click on the first atom, then \n\
single click on the second. As you touch additional atoms, the \n\
angle will be displayed on a red line. Double click the third \n\
atom to fix the angle report. \n\
\
<br><br> \n\
\
<img src="torsion.gif" align="left" border=1 hspace="4"> \n\
\
To measure a <b>torsion (dihedral) angle</b>, follow the same \n\
kind of procedure, except four atoms are needed. \n\
';

	return dah;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeSequenceLinks()
{
	var ssl =

'<center><b>Sequences</b></center> \n\
\
<br>';

if (validPDBId == "")
	ssl +=

'Because this structure is not associated with a published \n\
<a href="http://proteopedia.org/w/PDB_identification_code" \n\
target="_blank">PDB identification code</a>, \n\
sequence database links are not available. The sequence(s) may be \n\
available in SEQRES records if those are present in the PDB file, \n\
or in the ATOM records of the PDB file: \n\
<center><br> \n\
<a href="http://oca.weizmann.ac.il/oca-bin/send-pdb?id=' +

		validPDBId +

'" target="_blank">View PDB File</a> \n\
</center> \n\
';

else
	ssl +=

'Sequences for the chain(s) in <b>'

+ molTabLabel +

'</b> are available in several formats \n\
(all in <a href="http://proteopedia.org/w/Amino_Acids" \n\
target="_blank">one-letter code</a>). \n\
Sequence-identical chains are marked &quot;=&quot;: \n\
\
<ul> \n\
\
<li>Sequences of the crystallized chains, <b>often not full length</b>. \n\
\
<ul> \
<li>FASTA format (from  \n\
<a href="http://oca.weizmann.ac.il" \n\
target="_blank">OCA</a>): \n\
<center><font color="gray">';

var oca1 = 
'<a href="http://oca.weizmann.ac.il/oca-bin/send-seq?' +
		validPDBId + '_';

var oca2 = '" target="_blank">';
var atchain;

for (ci = 0; ci < chainList.length; ci++)
{
	if (ci > 0)
		ssl += ", &nbsp; ";
	for (cii = 0; cii < chainList[ci].length; cii++)
	{
		atchain = chainList[ci].charAt(cii);
		if (cii > 0)
			ssl += "=";
		ssl += oca1 + atchain + oca2 + atchain + '</a>';
	}
}

// PDBE

	ssl += 
'</font></center> \n\
</li> \n\
<br><li><a href="http://www.ebi.ac.uk/pdbe-srv/view/entry/' +

validPDBId +

'/primary.html" target="_blank">PDB-Europe</a> (\
<span style="background:#c0c0c0;">missing residues have \n\
a gray background</span>). \n\
</li>';

// PDB-USA / RCSB

	ssl +=
'<br><li> \n\
<a href="http://www.pdb.org/pdb/explore/remediatedSequence.do?structureId='

+ validPDBId +

'" target="_blank">PDB-USA (RCSB)</a>. \n\
</li>';

// UNIPROT

	ssl += 
'</ul><br><li>Sequences for <b>full-length</b> chains (including portions \n\
not crystallized): \n\
<ul><li> \n\
UniProt (sequence-identical chains are &quot;=&quot;):' +
		'<br><center>';

	ssl += makeUniProtChains() + "</center>";

	ssl +=
'</ul></ul> \n\
(A sequence-to-structure interface is under development for <i>FirstGlance \n\
in Jmol</i> but has not yet been completed.) \n\
';

	return ssl;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeUniProtChains()
{
	var unp1 = '<a href="http://www.uniprot.org/uniprot/';
	var unp2 = '.fasta" target="_blank">';

	var ssl = '<font color="gray">';

	pcount = 0;

	var upids = getUniProtID();
	var thischain;

	// must do this with sequence-id chains pre-grouped, e.g. chainList
	// for each group of seq-id chains
	for (var icg = 0; icg < chainList.length; icg++) 
	{
		ctype = chainTypeFromName(chainList[icg].charAt(0));

		if (match(ctype, "protein"))
		{
			if (icg > 0 && pcount > 0)
				ssl += ", &nbsp; ";
		}

		// for each chain in the group
		for (var ic = 0; ic < chainList[icg].length; ic++)
		{
			thischain = chainList[icg][ic];

			if (match(chainTypeFromName(thischain), "protein"))
			{

				if (ic > 0)
					ssl += "=";

				// find the UniProt ID
				for (var iup = 0; iup < upids.length; iup++)
				{
					// make the linked chain
					if (upids[iup].charAt(0) == thischain)
					{
						ssl += unp1 + upids[iup].substring(2) + unp2 +
						thischain + '</a>';
					}
				}
				pcount++;
			}
		}
	}

	ssl += '</font>.';

	return ssl;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
//function equalDelimit(str)
//{
//	var eqd = "";
//	for (var ied = 0; ied < str.length; ied++)
//	{
//		if (ied > 0)
//			eqd += "=";
//		eqd += str.charAt(ied);
//	}
//	return eqd;
//}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeBULink(pdbid)
{
	var getBULink = 
'<a href="biounit.htm?'

+ pdbid +

'" target="_blank">Get the Biological Unit for '

+ pdbid +

'</a>';

	return getBULink;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeAUHelp()
{
	var auh = "";

	if (validPDBId != "")
	{
		auh +=
'<center><big><b>'

+ makeBULink(validPDBId) +

'</b></big></center><br>';
	}

	auh +=
'<b>Asymmetric Unit vs. Biological Unit:</b><br><br> \n\
The \n\
<a href="http://proteopedia.org/w/Asymmetric_Unit" \n\
target="_blank">asymmetric unit</a> is the model that \n\
crystallographers publish in the \n\
<a href="http://proteopedia.org/w/Protein_Data_Bank" \n\
target="_blank">Protein Data Bank</a>. \n\
<i>Quite often, it is NOT the functional quaternary structure of the molecule</i>, \n\
which is called the \n\
<a href="http://proteopedia.org/w/Biological_Unit" \n\
target="_blank">biological unit</a>, biological assembly, or biomolecule. \n\
Therefore it is <b>very important</b> \n\
to look at the <b>biological unit</b>';

	if (validPDBId != "")
		auh +=	": " + makeBULink(validPDBId) + ".";
	else
	{
		
		auh +=
'. We recommend \n\
<a href="http://watcut.uwaterloo.ca/cgi-bin/makemultimer/" \n\
target="_blank">MakeMultimer</a> \n\
for constructing and visualizing biological units, but the current \n\
PDB file ';

	if (jgetfi("remark350") == "")
		auh +=
"does not include REMARK 350, which is necessary.";
	else
"may not have the necessary information in REMARK 350.";
	}

	auh +=
'<br><br> \n\
\
The asymmetric unit is the smallest part of a crystal from which the \n\
entire crystal can be constructed by duplication, translation and rotation. \n\
The biological unit may be <b>part</b> of the asymmetric unit \n\
(Case 1 below), <b>equal</b> to the \n\
asymmetric unit, or it may contain <b>multiple copies</b> \n\
of the asymmetric unit (Case 2 below). Here is \n\
<a href="http://proteopedia.org/w/Biological_Unit" \n\
target="_blank">more about determining biological units</a>. \n\
\
<br><br> \n\
\
Case 1: Serotonin N-acetyltransferase is a single-chain enzyme. However, \n\
the asymmetric unit in \n\
<a href="fg.htm?mol=1b6b" \n\
target="_blank">1b6b</a> \n\
is a homodimer formed as an artifact of crystallization. The interface \n\
between chains in the asymmetric unit is called a \n\
<a href="http://proteopedia.org/w/Crystal_contacts" \n\
target="_blank">crystal contact</a>. You can view either chain alone, \n\
each of which is a complete biological unit: '

+ makeBULink("1b6b") +

'<br><br> \n\
\
Case 2: Hemoglobin is a tetramer of four protein chains. However, \n\
the asymmetric unit for human oxyhemoglobin in \n\
<a href="fg.htm?mol=1hho" \n\
target="_blank">1hho</a> \n\
is a dimer. It takes two copies of the dimer to make up a functional \n\
hemoglobin molecule (a biological unit or biological assembly). '

+ makeBULink("1hho") +

'.<br><br> \n\
\
(The symmetry operations required to construct the biological \n\
unit are specified in the PDB file in REMARK 350.)';

	return auh;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeLigNSRHelp()
{
	var lnsr = 

'<center><b>Ligands+ and Non-Standard Residues</b></center> \n\
\
<br>  \n\
\
<b>Ligands+</b> are \n\
<a href="notes.htm#lig" \n\
target="_blank">defined here</a>. \n\
They can be toggled visible/hidden with the <i>Ligands+ Button</i> \n\
in the '

+ tab1Name_txt +

' and '

+ tab2Name_txt +

' Tabs. Ligands+ are listed in the '

+ tab0Name_txt +

' tab, where you can click each one to locate it. \n\
Ligands+ can be displayed as <b>ball and stick</b> models \n\
with a checkbox in the help that appears when they are toggled \n\
visible with the <i>Ligands+ Button</i>. \n\
You may wish to use <i>Hide..</i> (in the '

+ tab2Name_txt +

' tab) to hide protein or nucleic acid. \n\
Examples: \n\
<a href="fg.htm?mol=4b14" \n\
target="_blank">4b14</a>. \n\
';

	// NSR
	lnsr +=

'<br><br> \n\
<b>Non-Standard Residues</b> are residues in a protein or nucleic acid \n\
chain that are not one of the \n\
<a href="http://proteopedia.org/w/Standard_Residues" \n\
target="_blank">20 standard amino acids or 6 standard nucleotides</a>. \n\
<a href="http://proteopedia.org/w/Non-Standard_Residue" \n\
target="_blank">More..</a> \n\
\
<br><br>\n\
\
There are <b>'

+ nonStandardResidueCount +

'</b> non-standard residue(s) in ';

if (validPDBId != "")
	lnsr += validPDBId;
else
	lnsr += "this structure";

	if (nonStandardResidueCount == 0)
		lnsr +=
'. If present, they would be marked &quot;X&quot;, ';
	else
		lnsr +=
'. They are marked &quot;X&quot;, ';

	lnsr +=
'and listed in the '

+ tab0Name_txt +

' tab, where you can click each one to locate it. The &quot;X&quot; \n\
marks can be hidden with a checkbox in the '

+ tab1Name_txt +

' or '

+ tab2Name_txt +

' tabs. Non-standard residues can be displayed as <b>balls-and-sticks</b> \n\
with a checkbox in the help that appears when you click the \n\
Ligands+ button. \n\
You may wish to use <i>Hide..</i> (in the '

+ tab2Name_txt +

' tab) to hide protein or nucleic acid. \n\
Examples: \n\
<a href="fg.htm?mol=1apm" \n\
target="_blank">1apm</a> (protein), \n\
<a href="fg.htm?mol=1evv" \n\
target="_blank">1evv</a> (RNA). \n\
';





	return lnsr;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
