// Help for tab3 = Servers = control3.js</a></a>
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function makeEvolutionaryConservationHelp()
{
	var ech = '<center><b>Evolutionary Conservation</b></center>';

	if (validPDBId != "")
	{
		ech +=
'<br> \n\
<a href="http://proteopedia.org/w/'

+ validPDBId.toLowerCase() +

'" \n\
target="_blank"><big>Get it in Proteopedia</big></a>: \n\
Wait till the molecule appears in Proteopedia, then click <b>[show]</b> \n\
in the line <i>Evolutionary Conservation</i> \n\
below the molecule. If that line is absent, \n\
<a href="http://proteopedia.org/w/How_to_see_conserved_regions" \n\
target="_blank">go here</a>.<br>';

	}

	ech += 

'<br>The pattern of evolutionary conservation in a 3D \n\
protein structure helps to identify functional regions. \n\
<img align="right" src="an_4enl_consurf.gif" hspace="3" vspace="3"> \n\
For example, the catalytic pocket of enolase (a glycolytic enzyme) \n\
is <font color="#791c48"><b>highly conserved</b></font>, \n\
while conservation of the remainder of the surface \n\
is more <font color="#0dadb5"><b>variable</b></font>. \n\
Conserved regions of unknown function deserve investigation \n\
because they are likely to have important functions. \n\
\
<ul><li> \n\
<a href="http://proteopedia.org/w/Introduction_to_Evolutionary_Conservation" \n\
target="_blank">Introduction to Evolutionary Conservation</a> \n\
explains the example of Rett Syndrome. A detailed \n\
analysis of conservation of <b>enolase</b> includes  \n\
the multiple sequence alignment and <b>3D visualization</b>. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/How_to_see_conserved_regions" \n\
target="_blank">How to See Conserved Regions</a> describes three \n\
straightforward methods using the ConSurf Server. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/Conservation%2C_Evolutionary" \n\
target="_blank">Conservation, Evolutionary</a> briefly discusses \n\
\
	<ul><li> \n\
How ConSurf works and the color scheme it uses. \n\
	</li><li> \n\
Why <b>gly</b> and <b>pro</b> on protein surfaces are often conserved. \n\
	</li><li> \n\
Limitations of conservation analysis. \n\
	</li><li> \n\
Other conservation servers. \n\
	</li></ul> \n\
\
</li><li> \n\
<a href="http://proteopedia.org/w/ConSurfDB_vs._ConSurf" \n\
target="_blank">ConSurfDB vs. ConSurf</a> covers \n\
\
	<ul><li> \n\
Precalculated conservation vs. custom calculation. \n\
	</li><li> \n\
How to limit a custom calculation to proteins of a single function. \n\
	</li><li> \n\
How the ConSurfDB and ConSurf servers work. \n\
	</li></ul> \n\
\
</li></ul> \n\
';

	return ech;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function makeProteopediaHelp()
{
	var pdbid = getPDBId();
	var purl;
	var p1;
	var pph = "";

	pph +=
'<center><b>Proteopedia</b></center> \n\
<br> \n\
<img src="proteopedia.gif" align="right"> \n\
Proteopedia.Org is the easiest place for you to create new \n\
pages with <b>customized interactive \n\
scenes</b> of your molecule. You can show the \n\
<a href="javascript: showAUHelp()" \n\
target="_blank">biological or asymmetric unit</a> or \n\
a theoretical model, \n\
hide portions, display and color as you wish. \n\
Customizing is made easy by Proteopedia\'s <i>Scene \n\
Authoring Tools</i>, simple menus and forms. \n\
Molecular scenes that you create are <b>immediately \n\
online for sharing with anyone, anywhere</b>. \n\
See \n\
<a href="http://proteopedia.org/w/Proteopedia:Getting_Started" \n\
target="_blank">Getting Started in Proteopedia</a>. \n\
There are \n\
<a href="http://proteopedia.org/w/Proteopedia:Video_Guide" \n\
target="_blank">movies to show you how</a>. \n\
\
<br><br> \n\
\
Examples (simple): \n\
<ul><li> \n\
<a href="http://proteopedia.org/w/Nucleosomes" \n\
target="_blank">Nucleosomes</a>. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/Gramicidin_Channel_in_Lipid_Bilayer" \n\
target="_blank">Gramicidin Channel in Lipid Bilayer</a> \n\
(<a href="http://proteopedia.org/w/Canal_de_gramicidina_en_bicapa_lip%C3%ADdica_%28Spanish%29" \n\
target="_blank">espa&ntilde;ol</a>). \n\
</li></ul> \n\
Examples (well developed): \n\
<ul><li> \n\
<a href="http://proteopedia.org/w/Lac_repressor" \n\
target="_blank">Lac Repressor</a>. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/Avian_Influenza_Neuraminidase%2C_Tamiflu_and_Relenza" \n\
target="_blank">Avian Influenza Neuraminidase, Tamiflu and Relenza</a>. \n\
</li></ul> \n\
Uses of Proteopedia include: \n\
<ul><li> \n\
<a href="http://proteopedia.org/w/Teaching_Scenes%2C_Tutorials%2C_and_Educators%27_Pages" \n\
target="_blank">Lecture illustrations & tutorials</a>. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/Teaching_Strategies_Using_Proteopedia" \n\
target="_blank">Student projects</a>. \n\
</li><li> \n\
<a href="http://proteopedia.org/w/Interactive_3D_Complements_in_Proteopedia" \n\
target="_blank">Interactive 3D complements to journal publications</a>. \n\
</li><li> \n\
<a href="http://proteopedia.org/wiki/index.php/About_Macromolecular_Structure" \n\
target="_blank">Explanations of concepts in structural biology</a>. \n\
</li></ul> \n\
Every \n\
<a href="http://proteopedia.org/w/PDB_identification_code" \n\
target="_blank">PDB code</a> \n\
has a page in Proteopedia showing \n\
<a href="javascript: showEvolutionaryConservationHelp()"> \n\
evolutionary conservation</a> \n\
and structural and functional annotation. \n\
';

	if (pdbid.length > 0)
	{
		purl = "proteopedia.org/wiki/index.php/" +
			pdbid.toLowerCase();
		p1 = pdbid + " in ";

		pph += "<center><a href='http://"
			+ purl + "' target='_blank'>Go To "
			+ p1 + "Proteopedia.Org</a></center>";
	}


	
	return pph;	
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function makeMolProbityHelp()
{
	var mph = '<center><b>Atomic Clash Analysis: MolProbity</b> \n\
<br><a href="molprobi.htm" \n\
target="_blank">Step-by-step instructions</a> \n\
</center><br>';

	mph += 'The \n\
<a href="http://molprobity.biochem.duke.edu/" \n\
target="_blank">MolProbity Server</a> adds hydrogen atoms to the model, \n\
and then looks for atomic clashes. \n\
<table hspace="4" border="1" width="120" align="right"><tr><td> \n\
<img src="clash-mp-king.png"> \n\
</td></tr><tr><td><center> \n\
Clash between sidechain NH<sub>2</sub> and beta CH<sub>2</sub> of Gln105 \n\
in 1i01. Flipping the sidechain removes the clash. \n\
</center></td></tr></table> \n\
It reports an overall clash \n\
score, and compares it with clash scores for other X-ray results \n\
at similar resolution. A clash score substantially worse than \n\
average suggests that the model may contain significant errors. \n\
\
<br><br> \n\
\
MolProbity also flips the sidechains of Asn, Gln, and His by 180 \n\
degrees, and reports when the flipped sidechains have lower \n\
energy than the original positions. MolProbity also reports \n\
problems with bond lengths, angles, and \n\
<a href="http://proteopedia.org/wiki/index.php/Ramachandran_Plot" \n\
target="_blank">Ramachandran</a> \n\
outliers using the best available reference values. \n\
All this is completely automated and easy to use, but here are \n\
<center><br><b><a href="molprobi.htm" \n\
target="_blank">Step-by-step instructions.</a></b></center> \n\
';

// 1d66 new server clashscore=15.38/92%, mpscore=3.23/37%
// 1d66 old server clashscore=26.28/68%, mpscore=3.36/28%

	mph += 
'<br> \n\
Be sure to note the <b>free R</b> value in the '

+ tab0Name_txt +

' Tab above, and the corresponding reliability grade assigned \n\
to this model by <i>FirstGlance</i>. \n\
Other resources for evaluating the quality of this model are available at \n\
<a href="http://proteopedia.org/w/Quality_assessment_for_molecular_models" \n\
target="_blank">Quality Assessment for Molecular Models</a>. \n\
';

	return mph;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function makeUnfoldedHelp()
{
	var url = "disopred.htm";
	if (validPDBId != "")
		url += "?pdbid=" + validPDBId + "&missing=" + missingCount;

	var ufh = '<center><b>Predicting Intrinsically Disordered Regions</b> \n\
<br> \n\
<a href="' + url + '" \n\
target="_blank">Step-by-step instructions</a> \n\
</center><br>';

	ufh +=
'About 40% of eukaryotic proteins have at least one long (50 amino acids \n\
or more) disordered surface loop that does not fold with the rest of \n\
the protein chain. These intrinsically disordered (or natively unfolded) \n\
loops must remain flexible in order to perform their functions, which \n\
often involves binding to another folded protein partner. High charge \n\
density typically contributes to their remaining unfolded. \n\
\
<br><br> \n\
\
The ends of many protein chains, as well as loops within chains, are \n\
often disordered in protein crystals, and hence  \n\
<a href="javascript: showMissingReport()" \n\
target="_blank">missing</a> \n\
in the crystallographic models. Their absence \n\
suggests they may be intrinsically disordered. Here are \n\
\
<center><br><b> \n\
<a href="' + url + '" \n\
target="_blank">Step-by-step instructions</a> \n\
</b></center><br> \n\
\
for predicting which regions of a protein chain are intrinsically \n\
disordered. Here is more background on \n\
<a href="http://proteopedia.org/w/Intrinsically_Disordered_Protein" \n\
target="_blank">intrinsically disordered protein and \n\
prediction servers</a>. \n\
';

	return ufh;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function makeOPMHelp()
{
	var opmh = '<center><b>Lipid Bilayer Membrane Boundaries</b></center><br>';

	opmh +=

'Integral membrane protein structures have hydrophobic surfaces large \n\
enough to be buried within a lipid bilayer. The <i>Hydrophobic/Polar</i> \n\
view (in the '

+ tab1Name_txt +

' tab) makes it easy to see such surfaces. \n\
The boundaries \n\
between the hydrophobic surface and the polar/charged protein surfaces \n\
are used by the \n\
<center><br><b> \n\
<a href="http://opm.phar.umich.edu" \n\
target="_blank">Orientations of Proteins in Membranes Server</a> \n\
</b></center><br> \n\
\
<table align="right"><tr><td><center> \n\
<img src="potchan2.jpg"> \n\
<br> \n\
<img src="opm-key.jpg"> \n\
</center></td></tr></table> \n\
\
to predict the position of the protein in a lipid bilayer. \n\
This server adds pseudo-atoms (seen by <i>FirstGlance</i> as \n\
Ligands+) that depict the hydrophobic/hydrophilic \n\
boundaries in the 3D model. \n\
A classic example is  \n\
<a href="fg.htm?mol=1bl8" \n\
target="_blank">1bl8</a> (pictured at right), \n\
the first potassium channel structure \n\
to be solved crystallographically. Another example is porin, \n\
<a href="1hxx" \n\
target="_blank">1hxx</a>, where the biological unit is a trimer. \n\
';

	return opmh;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
