// Information about the model obtained from Jmol
/*

QUESTIONS

1bkx contains rna, a single A residue (no P), plus remainder protein.
How to find that the rna is not part of a chain?

4cpa has chain A 1-307 and a GLY ligand 308, not part of a chain
but assigned to chain A.
{chain=a and protein}.resno.max reports 308. 
How do I exclude the GLY308?

TODO

ssbonds!

report aa's not present in model (see code missingAAs() below)

can get chain and type without ref to header for no-header files

can get first and last residue (? see above)

hydrogens vs. non-hydrogens

SYNTAX

{:a and protein}.resno.max last residue in chain A excluding hetero
but not excluding non-standard residues, for example

in 1apm (3 nonstd AA's in chain E)
{:e and protein and hetero and *.ca}.count gives 3 for the non-std residues.

*/

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// stdAA is defined in util.js
/*
function missingAAs()
{
	var toeval, nca;

	for (iaa = 0; iaa < stdAA.length; iaa++)
	{
		toeval = "{" + stdAA[iaa] + ".ca}.count";
		if (!iaa) alert(toeval);
		nca = jmolEvaluate(toeval);
		if (!iaa) alert(nca);
	}
}
*/
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// DISULFIDES, CYS, MET

var sulfurCount;
var proteinSulfurCount;
var seleniumCount;
var proteinSeleniumCount;
var cysCount;
var disulfideCount;
var metCount;
var mseCount;
var cseCount; // selenocysteine

function getSulfurCounts()
{
	sulfurCount = jmolAtomCount("_S");
	proteinSulfurCount = jmolAtomCount("_S and protein");

	seleniumCount = jmolAtomCount("_Se");
	proteinSeleniumCount = jmolAtomCount("_Se and protein");

	cysCount = jmolAtomCount("cys.ca");
	disulfideCount = jmolAtomCount("cystine.ca")/2;

	metCount = jmolAtomCount("met.ca");
	mseCount = jmolAtomCount("mse.ca"); // selenomethionine

	cseCount = jmolAtomCount("cse.ca"); // selenocysteine
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
var waterCount;
var waterHydrogenCount;
var hydrogensPerWater;

function getWaterCount()
{
	waterCount = jmolAtomCount("water and oxygen");
	waterHydrogenCount = jmolAtomCount("water and hydrogen");
	hydrogensPerWater = 0;
	if (waterCount > 0)
		hydrogensPerWater = waterHydrogenCount / waterCount;
}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
