// errors up through # 27
// Translatable text is in txt10.js

var noFileHeader = false;
var nonHCount;

var resfloat;
var rfreefloat;

var expMethod = "";

var het3 = new Array();
var het3Count = new Array();
//var het3FullName = new Array();
var hetGroupCount;

var alphaCarbonCount;
var nonGlyAlphaCarbonCount;
var betaCarbonCount;
var c5primeCount;
var nucleicPhosphorusCount;
var incompleteSidechainsProteinCount;
var incompleteSidechainsNucleicCount;

var argCount;
var lysCount;
var hisCount;
var gluCount;
var aspCount;

var modelCount;
var perModel;

var chainZeroMissingBox;

var dateFooter;

var markBrokenEndsSpt = "# Not Yet Generated;";
var clearMarkBrokenEndsSpt = "# Not Yet Generated;";
var brokenEndsReport; // for development/debugging only

var dumCount = 0; // for OPM; see getDUM()
var pdbIsMakeMultimer = false;	


//
// 2D array format: chain name, missing count, missneg, misspos,
//   [first seq#, last seq#]n
// where there can be more than one first and last seq# pairs.
// Test cases:
// 2jqo none missing (NMR).
// 1nzp 1nzp: A 1 241 241 (single residue missing)
// 1o9a 1o9a: B 12 1 12 (CHAIN A, SEQDIFF FROM B, HAS NONE MISSING)
// EXAMPLE NEEDED: CHAIN WITH NONE MISSING SEQID TO CHAIN WITH SOME MISSING.
// 4asw 4asw: ["A", 13, 1, 13] ["B", 13, 1, 13]  ["C", 4, 16, 19]
//    total all chains: 30
// ABOVE EXAMPLES HAVE ONLY ONE MISSING SEGMENT PER CHAIN
// BELOW HAVE >ONE MISSING SEGMENT PER CHAIN
// 2ace 2ace: A 10 1 3 485 489 536 537 ONE CHAIN
// 1d66 1d66: A 9 1 7 65 66, B 9 1 7 5 66 TWO CHAINS
//
// 1tzn: 28 chains, 140 missing residues in 14 chains.
// 3fic: 27 chains, 27 missing residues in 1 chain.
// 3jqo=3JQO: 42 chains (3 distinct), 635 missing residues (32, 5, 8 per chain).
//   VARIABLE MISSING IN 2 OF 3 CHAINS.
// 3lo3: 28 chains (1 distinct), 0 missing residues. TWO CHAIN LINES.
//
// 4hix has 1 residue numbered 0 missing in chain L.
// 4en3 has missing with neg seq nums and 0.
// 2lex has missing DNA (2-letter residue names).
// 4ifd has missing RNA (1-letter residue names) among 435 missing residues
//   in 12 distinct chains <====== good xmpl of table simplifying.
// 4dqo has missing amino acids with INSERTION CODES.
// 1ucy has missing amino acids with INSERTION CODES in REVERSE alpha order!
//   also has a missing residue in just 1 of 3 seqID chains!
// 3nn8 has 2 sets of seqID chains, each set has some missing, some not.
// 4gxu has 926 missing AA - good xmpl of table simplifying! <==========
// 4dep has 174 missing AA, many negs, good xmpl of table simplifying! <==========
// 3omz has chain G length 259 with 156 missing (more than half!)

var missingCount = -1; // total missing for all chains
var missingNeg; // total missing neg charged for all chains
var missingPos; // total missing pos charged for all chains

		// Defining a 2D array without dimensions seems challenging.
		// Don't work: = new Array(), = [[]]
var missingPerChainInfo = new Array();
		// Max chains in a PDB file is 62 see 
		// http://proteopedia.org/w/Jmol/Visualizing_large_molecules#62_Chains
for (var i2d = 0; i2d < 70; i2d++)
{
	missingPerChainInfo[i2d] = new Array();
	missingPerChainInfo[i2d][0] = "";	
}

// Each missing segment has 4 values:
//   firstseq, firstseq-insertion-code, lastseq, lastseq-insertion-code
var mStep = 4;

// THESE ARE NOW LOCAL TO GETLENGTHS SO MEMORY WILL BE RELEASED
//var rawCompnd;
//var rawSource;
//var rawSeqres; 

var noSeqres; // Boolean
var chainCount;
var distinctChainCount;
var chainList = new Array();
var chainMolecules = new Array();
var chainLengths = new Array(); // in SEQRES order. Format "A 66".
var chainTypes = new Array(); // in SEQRES order
var chainDetails = new Array();
var useLowerCaseChains = false;

var rFree = new Array();
// res gq md bq
// Resolution, good quartile, median, bad quartile
// Values read from Fig. 3C in PMID:22000512
rFree[0] = [1.0, 0.135, 0.15, 0.165];

rFree[1] = [1.1, 0.145, 0.162, 0.185];
rFree[2] = [1.2, 0.155, 0.175, 0.195];
rFree[3] = [1.3, 0.162, 0.185, 0.21];
rFree[4] = [1.4, 0.185, 0.20, 0.22];
rFree[5] = [1.5, 0.19, 0.21, 0.228]; // bq 0.23

rFree[6] = [1.6, 0.195, 0.215, 0.232]; // bq 0.23
rFree[7] = [1.7, 0.20, 0.22, 0.235];
rFree[8] = [1.8, 0.21, 0.228, 0.245]; // md 0.23
rFree[9] = [1.9, 0.215, 0.232, 0.25]; // md 0.23
rFree[10] = [2.0, 0.22, 0.24, 0.26];

rFree[11] = [2.1, 0.228, 0.245, 0.263]; // gq 0.23
rFree[12] = [2.2, 0.232, 0.25, 0.266]; // gq 0.23
rFree[13] = [2.3, 0.238, 0.254, 0.272]; // gq 0.24
rFree[14] = [2.4, 0.242, 0.258, 0.275]; // gq 0.24
rFree[15] = [2.5, 0.245, 0.265, 0.28];

rFree[16] = [2.6, 0.248, 0.268, 0.285];
rFree[17] = [2.7, 0.25, 0.27, 0.29];
rFree[18] = [2.8, 0.255, 0.273, 0.293];
rFree[19] = [2.9, 0.257, 0.276, 0.295];
rFree[20] = [3.0, 0.26, 0.28, 0.297];

rFree[21] = [3.1, 0.265, 0.285, 0.308];
rFree[22] = [3.2, 0.268, 0.29, 0.31];
rFree[23] = [3.3, 0.27, 0.295, 0.315];
rFree[24] = [3.4, 0.273, 0.30, 0.32];
rFree[25] = [3.5, 0.275, 0.305, 0.33];

rFree[26] = [4.0, 0.28, 0.31, 0.35]; // From RCSB 3.9-4.1, 199 having Rfree

var uncapw = new Array();
// de 3znh
// de los 2lwm
// del 4db2
// der NOT 3v1a "B. S. Der,"
// van 3znh
uncapw = ["DE", "DEL", "DEN", "DER", "LOS", "VAN"];

var twoCapsName = new Array();
twoCapsName = ["MACDONALD", "MACELREVEY", "MACGILLIVRAY",
"MACKENZIE", "MACKERELL",
"MACKINNON", "MACMILLAN", "MACPHERSON", "MACRAE"];


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeMoleculePanel()
{
// These were experimental:
//	exploreChainInfo();
//	firstAndLastResNos();

	if (!getHeaderBlocks())
	{
		noFileHeader = true;
		return noHeader();
	}

	var ptx = rawTitle + makeMoltabButtons();

	ptx += '<ul>\n';

	ptx += '<li>' + getReleaseYear();

	ptx += Method_txt + ": " + getMethod() + '</li>';

	if (!match(expMethod, "nmr"))
		ptx += '<li>' + getRes() + '</li>';

	// Need to get missing before chains.
	// getChains() generates a report including missing.
	var holdMissing = getMissingCount();

	ptx += getChains(); // includes <li>...</li> and sub <ul>

	ptx += "<li>" + getResidueCounts() + "</li>";

	ptx += "<li>" + holdMissing + "</li>";

	if (!match(expMethod, "nmr"))
	{
		ptx += '</ul>\n'; // close sub <ul> from getChains()
		ptx += '<li><a href="javascript: showAUHelp()">' +
			'Biological Unit</a></li>';
	}

	var holdHetNam = getHetNam();

	ptx += "<li>Ligands+ and Non-Standard Residues: " + 

'<a href="javascript: showLigNSRHelp()">' +
'<img src="help-icon24.png" border="0" align="center"></a>' +

			"<ul>" +
			holdHetNam + "</ul></li>";

	ptx += '</ul>\n';

	ptx += getJrnl();

	ptx += "<br>" + getPDBFile();

	ptx += "<br><br>" + dateFooter + 
'<br><br>' + ExtractedFromPDB_txt +
' \n\
<a href="http://proteopedia.org/w/Atomic_coordinate_file" \n\
target="_blank" title="' + WhatIsPDBFile_TT + '" \n\
><img src="help-icon24.png" border="0" align="center"></a>';

	ptx += '<form name="moltabForm">';

	ptx += putBottomControls(0); // control panel number

	ptx += '</form>';

//	ptx += "<center>" + makeBottomLinks() + makeLabelsCheckboxes() + "</center>";

	// This adds broken-ends markers to the view. Why here? See startup.txt.
	if (missingCount > 0)
	{
		brokenEndsReport = makeMarkBrokenEndsSpt(); // defines markBrokenEndsSpt
		doMolViewSpt(""); // applies markBrokenEndsSpt
		makeClearMarkBrokenEndsSpt(); // for later use
	}

	// These prepare information for later use (not displayed in top panel)
	makeChainDetails(); // prepares chainDetails, needs missing info
	getWaterCount(); // just to get waterCount, used in water button but not yet
	getCharges(); // just to get waterCount, used in water button but not yet
		// used here.

	return ptx;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeMoltabButtons()
{
	// incolumn is false; cptab is 0
	return ("<center>" + makeBkgSpinZoomButtons(false, 0) + "</center>");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function noHeader()
{
	var noh = rawTitle + makeMoltabButtons() + "<br>";

	noh += getMakeMultimer();

	noh += getDUM(); // OPM

	noh +=
'This \n\
<a href="http://proteopedia.org/w/Atomic_coordinate_file" \n\
target="_blank">PDB data file</a> \n\
lacks required standard information. \n\
This typically occurs when the model was generated by a \n\
server such as the Biological Unit server (MakeMultimer) \n\
or the Orientations of Proteins in Membranes server, \n\
or comes from a source different from the \n\
<a href="http://proteopedia.org/w/Protein_Data_Bank" \n\
target="_blank">Protein Data Bank.</a> \n\
';

	noh += "<ul><li>" + getResidueCounts() + "</li></ul>";

	if (validPDBId.length > 0)
		noh +=
'Please consult the official published PDB file \n\
<a href="fg.htm?mol=' + validPDBId + '" \n\
target="_blank">' + validPDBId + '</a> \n\
for key information about this model. \n\
';
	else
		noh +=
'Please consult the source of this data file for \n\
further information. <i>FirstGlance</i> did not find a \n\
<a href="http://proteopedia.org/w/PDB_identification_code" \n\
target="_blank">PDB code</a> \n\
in this data file. \n\
';

	noh +=
'<br><br>The capabilities under the '

+ tab1Name_txt + ', '
+ tab2Name_txt + ', and '
+ tab3Name_txt +

' tabs will work normally as they do not depend on \n\
this missing information.  \n\
';

	noh +=
'<br><br>' + getPDBFile();

	noh += "<br><br><center>" + makeBottomLinks()
		+ makeLabelsCheckboxes() + "</center>";

	// These prepare information for later use (not displayed in top panel)
//	makeChainDetails(); // prepares chainDetails, needs missing info
	getWaterCount(); // just to get waterCount, used in water button but not yet
	getCharges();
		// used here.

	return noh;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getMakeMultimer()
{
	var mmreport = "";

	var header = jmolGetPropertyAsString("fileHeader");
	if (header.indexOf("MakeMultimer.py") != -1)
		pdbIsMakeMultimer = true;	

	if (pdbIsMakeMultimer)
	{
		mmreport =
'<b>BIOLOGICAL UNIT</b> generated by the <i>MakeMultimer Server</i> \n\
(available under the <i>' + tab3Name_txt + '</i> tab).<br><br>';

	}	

	return mmreport;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getDUM()
{
	var drpt = "";

	// OPM files (Orientations of Proteins in Membranes) contain
	// large numbers of pseudo-atoms DUM.O and DUM.N

	var dumo = jmolEvaluate("{dum.o}.count");
	var dumn = jmolEvaluate("{dum.n}.count");
	dumCount = dumo + dumn;

	if (dumCount > 0)
	{
//		alert("There are " + dumCount + " (DUM.O + DUM.N) atoms.");
// 1bl8: 1058
// 7ahl: 4050

		drpt +=
'<img src="opm-key.jpg" align="right" hspace="5"> \n\
This model was generated by the server <i>Orientations of Proteins \n\
in Membranes</i> (available under the <i>'

+ tab3Name_txt +

'</i> tab). \n\
The server added \n\
<font color="red"><b>red</b></font> and\n\
<font color="blue"><b>blue</b></font> \n\
pseudo-atoms to mark the hydrophobic boundaries \n\
of the lipid bilayer. They can be toggled on/of (and made smaller) \n\
with the <i>Ligands+</i> button (under the <i>Views</i> and <i>Tools</i> \n\
tabs).<br><br> \n\
';
	}
		

	return drpt;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getHeaderBlocks()
{
	rawTitle = getTitle();
	if ((rawRevdat = jgetfi("revdat")) == "")
		return false;
	if ((rawExpdta = jgetfi("expdta")) == "")
		return false;
	if ((rawRemark3 = jgetfi("remark3")) == "")
		return false;

	rawHeader = jgetfi("header");

	return true;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getReleaseYear()
{
	var revdat = rawRevdat;
	var datedepos = rawHeader;
	datedepos = datedepos.substring(40,49);

	// "revdat 1 date pdbcode 0" is always below any subsequent lines,
	// so it is last, so work back from the end.
	yrrel = revdat.substring(revdat.length - 14, revdat.length - 12);
	var daterel = revdat.substring(revdat.length - 21, revdat.length - 12);

	var tooltip = Deposited_txt + " " + datedepos + ". " +
		Released_txt + " " + daterel + ".";

	dateFooter = "*" + tooltip + " " + DateFooter_txt;

	iyr = parseInt(yrrel);

	if (iyr > 70)
		yrrel = "19" + yrrel;
	else
		yrrel = "20" + yrrel;

	var yearrpt = "<b><a title='" + tooltip + "'>" +
		yrrel + "*</a></b>. &nbsp; ";

	return yearrpt;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getHetNam()
{
	het3.length = 0;
	var het3Jmol;

	var igot = jgetfi("hetnam");

	var ilines = igot.split("\\n"); // and also reformatted lines for report

	var prev3 = "";
//	var sp6 = " &nbsp; &nbsp; &nbsp;";

	for (ii = 0; ii < ilines.length; ii++)
	{
		var iln = ilines[ii];

		var isp = iln.indexOf(" ");
		if (isp != -1)
		{
			// GET CODE & COUNT
			het3[ii] = iln.substring(0, isp);
			// thanks to Alexander Rose alexander.rose@weirdbyte.de
			het3Jmol = "{[" + het3[ii] + "]";
			if (modelCount > 1)
				het3Jmol += " and model=1";
			het3Jmol += "}.groupindex.all.count().length";
			het3Count[ii] = jmolEvaluate(het3Jmol);

			var het3raw = het3[ii];

			if (het3raw == prev3)
				// INDENT CONTINUATION LINES WITHOUT REPEATING CODE
				het3padded = "";
			else // NEW CODE
			{
				// PAD CODES LENGTH < 3
				het3padded = het3[ii];
				while (het3padded.length < 3)
					het3padded += " ";
			}

			// LINK THE CODE
			var hcode = "";
			if (het3padded.length == 3)
				hcode = "<a href='javascript: haloHet(" + ii + ")' " +
				"title='" + HaloLigand_TT + "'>";

			hcode += "<big><tt>" + het3padded + "</tt></big>";

			if (het3padded.length == 3)
			{
				hcode += "</a>:";
				hcode = "<li>" + het3Count[ii] + " " + hcode;
			}

			// FULL NAME
			// spaces in full name are generated by line breaks in the PDB file
			iln = iln[isp + 1] + // capital first letter
				iln.substring(isp + 2).toLowerCase();

			iln = hcode + " " + iln;

			if (het3padded.length == 3)
				iln += "</li>";

			prev3 = het3raw;
		}

		ilines[ii] = iln;
	}
	ilines.length = ilines.length - 1; // trim off blank end item

	hetGroupCount = ilines.length;

	if (ilines.length == 0)
		ilines[0] = "<li>None</li>";

	igot = ilines.join("\n");

	if (modelCount > 1 && hetGroupCount > 0)
		igot += "(Ligand+/NSR counts are for model 1.)";

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function haloChain(chn)
{
	findIt("chain=" + chn);
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function haloHet(ihet)
{
	var fq = "[" + het3[ihet] + "] and hetero"; // in 4cpa, gly ligand is hetero
	// but there are lots of glys in the protein

	findIt(fq);
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getRes()
{
	var ptx = "";

	// electron microscopy/crystallography both have resolutions
	if (match(expMethod, "x-ray") || match(expMethod, "electron") ||
		match(expMethod, "neutron diffraction"))
	{
		ptx +=
"<a href='http://proteopedia.org/w/Resolution' \n\
target='_blank' title='" + ExplanationInProteopedia_TT + "'>" +
Resolution_txt + "</a>: \n\
<b>" + getresval() + "</b> &Aring;";

		if (match(expMethod, "x-ray"))
		{
			var qual = ": <b>";

			if (resfloat < 1.6) qual += EXCELLENT_txt;
			if (resfloat >= 1.6 && resfloat < 1.8) qual +=
				EXCELLENT_txt + "/" + VERY_GOOD_txt;
			if (resfloat >= 1.8 && resfloat < 2.0) qual += VERY_GOOD_txt;
			if (resfloat >= 2.0 && resfloat < 2.3) qual +=
				VERY_GOOD_txt + "/" + GOOD_txt;
			if (resfloat >= 2.3 && resfloat < 2.6) qual += GOOD_txt;
			if (resfloat >= 2.6 && resfloat < 2.9) qual +=
				GOOD_txt + "/" + FAIR_txt;
			if (resfloat >= 2.9 && resfloat < 3.2) qual += FAIR_txt;
			if (resfloat >= 3.2 && resfloat < 3.5) qual +=
				FAIR_txt + "/" + POOR_txt;
			if (resfloat >= 3.5) qual += POOR_txt;

			ptx += qual + "</b>" +
		 		' <a href="notes.htm#grading" ' +
				'target="_blank"><img src="help-icon24.png" border="0" ' +
				'align="center"></a>';

			ptx += getRvalRfree();
		}
		else ptx += ".";
	}

	return ptx;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getRvalRfree()
{
	var notFound =
' <a href="javascript: showNotFound()" \
title="' + ClickForExplanation_TT + '">\
Not Found</a>';

	var iraw = rawRemark3;

	var igot = " R<sub>val</sub>: ";

	// for cases depending on software used, see
	// http://www.wwpdb.org/documentation/format33/remark3.html

	var rvalkey =  "R VALUE            (WORKING SET) : ";
  var rvalkey1 = "R VALUE            (WORKING SET)  : "; // 1vu2, 4ak4
	var rvalkey2 = "R VALUE     (WORKING + TEST SET) : "; // 2bop
	// software=SHELXL-97 e.g. 1o1o, 3vqj, 3w07
	var rvalkey3 = "R VALUE          (WORKING SET, NO CUTOFF) : ";
	var rvalkey4 = "R VALUE   (WORKING + TEST SET, NO CUTOFF) : ";

	var irval = iraw.indexOf(rvalkey);
	var keyLength = rvalkey.length;

	if (irval == -1) // software=BUSTER: 1vu2, 4ak4
	{
		irval = iraw.indexOf(rvalkey1);
		keyLength = rvalkey1.length;
	}

	if (irval != -1) // 2bop
	{
		var nullTest = iraw.substring(irval + keyLength).substring(0, 4);
//		alert("moltab.js #7: nullTest:" + nullTest + ":");
		if (nullTest == "NULL")
		{
			irval = iraw.indexOf(rvalkey2);
			keyLength = rvalkey2.length;
		}
	}
//	if (irval == -1) // no known case
//		irval = iraw.indexOf(rvalkey2);
	
	if (irval == -1) // 1o1o etc. SHELXL-97
	{
		irval = iraw.indexOf(rvalkey3);
		keyLength = rvalkey3.length;
	}
	if (irval != -1) // 2bop
	{
		var nullTest = iraw.substring(irval + keyLength).substring(0, 4);
//		alert("moltab.js #7b: nullTest:" + nullTest + ":");
		if (nullTest == "NULL")
		{
			irval = iraw.indexOf(rvalkey4);
			keyLength = rvalkey4.length;
		}
	}

	// REPORT R VALUE
	if (irval != -1)
	{
		igot += iraw.substring(irval + keyLength);
		igot = igot.substring(0, igot.indexOf("\\n"));
	}
	else
		igot += "?";

	igot += "</li><li><a href='http://proteopedia.org/w/Free_R' " +
		"target='_blank' title='" +
		ExplanationInProteopedia_TT +
		"'>Reliability</a>: " +
		"R<sub>free</sub> = ";

	var rfreekey =  "FREE R VALUE                     : ";
	var rfreekey1 = "FREE R VALUE                      : "; // 1vu2, 4ak4
	var rfreekey2 = "FREE R VALUE                  (NO CUTOFF) : "; // 1o1o

	var rfs = "";

	var irf = iraw.indexOf(rfreekey);
	var freeKeyLength = rfreekey.length;

	if (irf == -1) // software=BUSTER: 1vu2, 4ak4
	{
		irf = iraw.indexOf(rfreekey1);
		freeKeyLength = rfreekey1.length;
	}

	if (irf == -1) // 1o1o
	{
		irf = iraw.indexOf(rfreekey2);
		freeKeyLength = rfreekey2.length;
	}

	if (irf != -1)
	{
		rfs = iraw.substring(irf + freeKeyLength);
		rfs = rfs.substring(0, rfs.indexOf("\\n"));
		rfreefloat = parseFloat(rfs);
		
		igot += rfs;
	}
	else
		igot += notFound;

	// NULL 1bsg
	if (rfs == "NULL" || rfs.length == 0)
	{
		igot += ":" + notFound;
		// add help icon
		igot += ' <a href="javascript: showFreeRHelp()">' +
			'<img src="help-icon24.png" border="0" align="center"></a>';
	}
	else
		igot += ": " + gradeFreeR();

	return igot;		
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getPDBFile()
{
	var igot;

	if (!noFileHeader && validPDBId != "")
	{

	// RCSB
//	igot = '<a href="http://www.pdb.org/pdb/files/' +
//		validPDBId +
//		'.pdb" target="_blank">View PDB File</a>';

	// OCA
	igot = '<a href="http://oca.weizmann.ac.il/oca-bin/send-pdb?id=' +
		validPDBId +
		'" target="_blank">View PDB File</a>';
	}
	else

// ALWAYS BEST TO SHOW THE ACTUAL FILE WE'RE WORKING WITH!

	{
		// but for an RCSB PDB code, this method generates
		//java.security.AccessControlException: access denied
		//(java.net.SocketPermission www.rcsb.org:80 connect,resolve)

		igot =
		'<a href="javascript: showPDBFile()">View PDB File</a>';
	}

	igot += ' <a href="http://proteopedia.org/w/Atomic_coordinate_file" ' +
		'target="_blank"  title="What is a PDB File?">' +
		'<img src="help-icon24.png" border="0" align="center"></a>';

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showPDBFile()
{
	showSptInWindow(jmolGetPropertyAsString("fileContents"));
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getTitle()
{
	var ttl = jgetfi("title");
//	alert("moltab.js #10 getTitle returns:" + ttl + ":");

	// replace newlines with spaces
	ttl = ttl.replace(/\\n/g, " ");	

	return ttl;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getJrnl()
{
	var iauth = getAuthors();

	var igot = jgetfi("jrnl");

	ipm = igot.indexOf("\\nPMID");

	if (ipm == -1) // unpublished, at least no pubmed id
		igot = "<br>(No publication in PubMed.)";
	else
	{
		igot = igot.substring(ipm + 6);

		igot = igot.substring(0, igot.indexOf("\\n"));

		// delete spaces
		igot = igot.replace(/ /g, "");

		//	alert("|" + igot + "|");

		igot = '<br><a href="http://www.ncbi.nlm.nih.gov/pubmed/?term=' +
			igot + '" target="_blank">Abstract at PubMed</a>.';
	}

	igot = iauth + igot;

	igot += " &nbsp; <a href='javascript: showAllCits()'>All Citations</a>.";

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showNotFound()
{
	cancelPendingAndShowHelp("makeNotFound()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeNotFound()
{
	var nf =
'<b>Not Found:</b><br><br> \n\
When <i>FirstGlance in Jmol</i> is unable to find the \n\
<a href="http://proteopedia.org/w/R_value" \n\
target="_blank">R value</a> \n\
or the \n\
<a href="http://proteopedia.org/w/Free_R" \n\
target="_blank">free R value</a> \n\
in the \n\
<a href="http://proteopedia.org/w/Atomic_coordinate_file#PDB_Data_Format" \n\
target="_blank">PDB file</a>, the value may not have been reported in the \n\
PDB file by the authors, or <i>FirstGlance \n\
may be failing to find the value</i>. To find out whether a \n\
value has been reported, \n\
click on <i>View PDB File</i> in the top panel (tab '

+ molTabLabel +

'), and carefully \n\
examine REMARK 3. \n\
<br><br> \n\
If you find a case where <i>FirstGlance in Jmol</i> fails to find a value \n\
that is present in the PDB \n\
file, please report the PDB code to '

+ make_contact_address("FGiJ_Not_Found", ".") +

'<br><br> \n\
\
When <i>FirstGlance</i> does find a value for free R, that value is used to \n\
<a href="javascript: showFreeRHelp()">grade \n\
the reliability of the model.</a> \n\
';

	return nf;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showAllCits()
{
	cancelPendingAndShowHelp("makeAllCits()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeAllCits()
{
	// JRNL
	var ij = jgetfi("jrnl");
//	alert("moltab.js #2: JRNL |" + ij + "|");

	if (ij.length == 0)
		ij = "(None.)<br>";
	else
		ij = ij.replace(/\\n/g, "<br>");	

	ij = formatCit(ij);

	ij = linkPMID(ij);

	// REMARK 1
	var ic = jgetfi("remark1");

	if (ic.length == 0)
		ic = "<br>(None.)";
	else
	{
		ic = ic.replace(/\\n/g, "<br>");	

		if (ic.length == 4) // was just a newline
			ic = "<br>(None.)";

		else
		{
			var refs = ic.split("<br>REFERENCE ");
			// skip the 0th which is empty
//			alert("moltab.js #5: refs.length=" + refs.length);
			for (var ii = 1; ii < refs.length; ii++)
			{
				refs[ii] = formatCit(refs[ii]);
				refs[ii] = linkPMID(refs[ii]);
			}
			ic = refs.join("<br><br>REFERENCE ");
			ic = ic.substring(4); // trim off extra leading <br>
		}
	}

//	alert("|" + ic + "|");

	var igot = "<center><b>Primary Citation*</b></center>" +

"<br>" + ij;

	igot += "<br><center><b>Additional Citations**</b></center>" + ic;

	// boldface ref lines
	while((iref = igot.indexOf("<br>REF ")) != -1)
	{
		igot = igot.replace(/<br>REF /, "<br><b>");
		iref2 = igot.indexOf("<br>", iref + 6);
		igot = igot.substring(0, iref2) + "</b>" + igot.substring(iref2);
	}

	igot = igot.replace(/<br>TITL 2 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 3 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 4 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 5 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 6 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 7 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 8 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL 9 /g, " "); // must before TITL!
	igot = igot.replace(/<br>TITL /g, "<br>");
	igot = igot.replace(/<br>REF /g, "<br>");
	igot = igot.replace(/<br>REFN /g, "<br>");

// done above with join
//	igot = igot.replace(/<br>REFERENCE /g, "<br><br>REFERENCE ");

	igot +=
"<br><br>* Primary citation is from the JRNL record in the \n\
<a href='http://proteopedia.org/w/Atomic_coordinate_file#PDB_Data_Format' \n\
target='_blank'>PDB file</a>. \n\
<br>** Additional citations are from REMARK 1 in the PDB file. ";


	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function linkPMID(igot) // igot must be a single reference
{
//	alert("moltab.js #6p: linkPMID() gets\n" + igot);

	var pm1;
	var pm2;
	var pm3;

	// link PMID
	var pmkey = "<br>PMID   "; // 3 spaces!
	var ipm = igot.indexOf(pmkey);

	if (ipm != -1)
	{
		pm1 = igot.substring(0, ipm);
		pm2 = igot.substring(ipm + pmkey.length);

		var ipmbr = pm2.indexOf("<br>");
		if (ipmbr != -1)
		{
			pm3 = pm2.substring(ipmbr); // <br> and after
			pm2 = pm2.substring(0, ipmbr); // PM up to <br>
		}
		else // no trailing <br> true for REFS 1 to N-1
		{
			pm3 = ""; // nothing post <br>
			// pm2 unchanged
		}

		igot = pm1 + pmkey + "<a href='http://www.ncbi.nlm.nih.gov/pubmed/?term=" +
			pm2 + "' target='_blank'>" + pm2 + "</a>" + pm3;
	}
//	alert("moltab.js #4: linkPM() returns:\n" + igot);

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function linkDOI(igot) // igot must be a single reference
{
//	alert("moltab.js #6: linkDOI() gets\n" + igot);

	var doi1;
	var doi2;
	var doi3;

	// link DOI
	var doikey = "<br>DOI    "; // 4 spaces!
	var idoi = igot.indexOf(doikey);

	if (idoi != -1)
	{
		// delete delimiter for second DOI line
		igot = igot.replace(/<br>DOI  2 /, "");

		doi1 = igot.substring(0, idoi);
		doi2 = igot.substring(idoi + doikey.length);

		var idoibr = doi2.indexOf("<br>");
		if (idoibr != -1)
		{
			doi3 = doi2.substring(idoibr); // <br> and after
			doi2 = doi2.substring(0, idoibr); // DOI up to <br>
		}
		else // no trailing <br> true for REFS 1 to N-1
		{
			doi3 = ""; // nothing post <br>
			// doi2 unchanged
		}

		igot = doi1 + doikey + "<a href='http://dx.doi.org/" +
			doi2 + "' target='_blank'>" + doi2 + "</a>" + doi3;
	}
//	alert("moltab.js #4: linkDOI() returns:\n" + igot);

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function formatCit(igot)
{
//	alert("moltab.js #3d: formatCit() gets\n" + igot);

	// split authors from remainder of reference
	var ititl = igot.indexOf("<br>TITL ");
	if (ititl != -1)
	{
		// separate iauth
		var iauth = igot.substring(0, ititl);
		var itail = igot.substring(ititl);

		iauth = formatAuth(iauth);

		igot = iauth + itail;

// this is going after <br>
//		if (igot.charAt(igot.length - 1) != ".")
//			igot += ".";
	}

	igot = linkDOI(igot);

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function formatAuth(iauth)
{
		// add spaces after commas and periods
		iauth = iauth.replace(/,/g, ", ");
		iauth = iauth.replace(/\./g, ". ");
//		alert("moltab.js #3c: iauth=\n" + iauth);

		// split into space-delimited words
		var aww = iauth.split(" ");
		// skip 0th which is AUTH or 1<br>AUTH
//		alert("moltab.js #3a: aww=\n" + aww);
		for (ii = 1; ii < aww.length; ii++)
		{
			// Change each word from upper case to capitalized.
			// Extra spaces make empty "words" length 0
			// don't change AUTH 2 to auth 2, etc.
			if (dontCap(aww[ii]))
			{
				aww[ii] = aww[ii].toLowerCase();
			}
			else if (aww[ii].length > 0 && aww[ii] != "<br>AUTH")
				aww[ii] = aww[ii][0] + aww[ii].substring(1).toLowerCase();

			// Change Macdonald to MacDonald, Mcclellan to McClellan //2o2n
			// D'arcy to D'Arcy, O'connell to O'Connell

			// all Mc's get 2nd cap
			if (aww[ii].substring(0, 2) == "Mc")
				aww[ii] = setCharAt(aww[ii], 2, aww[ii].charAt(2).toUpperCase());
			// Only Mac's in list get 2nd cap
			if (needsCap2(aww[ii]))
			{
				if (aww[ii].substring(0, 3) == "Mac")
					aww[ii] = setCharAt(aww[ii], 3, aww[ii].charAt(3).toUpperCase());
			}
			// all D' get 2nd cap: 
			if (aww[ii].substring(0, 2) == "D'")
				aww[ii] = setCharAt(aww[ii], 2, aww[ii].charAt(2).toUpperCase());
			// all O' get 2nd cap: 
			if (aww[ii].substring(0, 2) == "O'")
				aww[ii] = setCharAt(aww[ii], 2, aww[ii].charAt(2).toUpperCase());
		}
		iauth = aww.join(" ");

		// Capitalize words/initials after hyphens (1o1o, 2p3u)
		var ihy;
		var istart = 0;
		while((ihy = iauth.indexOf("-", istart)) != -1)
		{
			iauth = iauth.substring(0, ihy + 1) +
				iauth.charAt(ihy + 1).toUpperCase() +
				iauth.substring(ihy + 2);
			istart = ihy + 1;
		}

		// Delete spaces before hyphens, for initials: A. -B. -> A.-B.
		iauth = iauth.replace(/\ \-/g, "-");

		// delete leading AUTH\ \ \  not preceded by <br>
		iauth = iauth.replace(/AUTH\ \ \ /, "")

//		alert("moltab.js #3b: iauth=\n" + iauth);

		iauth = iauth.replace(/<br>AUTH 2 /g, "");
		iauth = iauth.replace(/<br>AUTH 3 /g, "");
		iauth = iauth.replace(/<br>AUTH 4 /g, "");
		iauth = iauth.replace(/<br>AUTH 5 /g, "");
		iauth = iauth.replace(/<br>AUTH 6 /g, "");
		iauth = iauth.replace(/<br>AUTH 7 /g, "");
		iauth = iauth.replace(/<br>AUTH 8 /g, "");
		iauth = iauth.replace(/<br>AUTH 9 /g, "");
//iauth = iauth.replace(/<br>AUTH /g, "<br>"); // stripped out in for loop above
//iauth = iauth.replace(/<br>/g, " "); // strips 1<br>first author

	return iauth;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function needsCap2(wrd) // for author words
{
//	alert("moltab.js #8 needsCap2() gets " + wrd);
	for (var iw = 0; iw < twoCapsName.length; iw++)
	{
		// strip trailing comma, and uppercase
		var wrdnocom = wrd.toUpperCase().substring(0, wrd.length - 1);
		if (wrdnocom == twoCapsName[iw])
			return true;
	}
	return false;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function dontCap(wrd) // for author words
{
	for (var iw = 0; iw < uncapw.length; iw++)
	{
		if (wrd == uncapw[iw])
			return true;
	}
	return false;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getAuthors()
{
	var igot = jgetfi("author");

	igot = igot.replace(/\\n/g, " ");

	igot = formatAuth(igot);

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getMethod()
{
	var mtd = rawExpdta;

	// delete newlines
	mtd = mtd.replace(/\\n/g, "");

	expMethod = mtd;

	var url = "";

	if (match(mtd, "nmr"))
		url = "http://proteopedia.org/w/NMR";

	if (match(mtd, "x-ray"))
		url = "http://proteopedia.org/w/X-ray_crystallography";

	if (url.length > 0)
		mtd = '<a href="' + url + '" target="_blank"' +
			' title="' + ExplanationInProteopedia_TT + '">'
			+ mtd + '</a>';

//	if (match(expMethod, "nmr")) ALSO X-RAY!
		mtd += getModels();

	mtd += getMdlTyp();

	return mtd;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getMdlTyp()
{
	// MDLTYP present in 1,001 entries, often MINIMIZED AVERAGE e.g. 1imo
	// but also alpha carbons only e.g. 3tb8
	var igot = jgetfi("mdltyp");

	// delete newlines
	igot = igot.replace(/\\n/g, "");

	if (igot.length > 0)
		igot = " &nbsp; " + igot;

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getModels()
{
	var nummdl = -1;
	var confsub = -1;
	var confsubkey = "CONFORMERS, NUMBER SUBMITTED    : ";

	// NUMMDL
	var igot = jgetfi("nummdl");

	// delete newlines
	igot = igot.replace(/\\n/g, "");
	// delete spaces
	igot = igot.replace(/ /g, "");

	if (igot.length > 0)
		nummdl = parseInt(igot);

	// CONFORMERS SUBMITTED
	igot = jgetfi("remark210");
	var iconsub = igot.indexOf(confsubkey);
	if (iconsub != -1)
	{
		igot = igot.substring(iconsub + confsubkey.length);
		igot = igot.substring(0, igot.indexOf("\\n"));
		confsub = parseInt(igot);
	}

	if (nummdl != confsub && nummdl != -1 && confsub != -1)
	{
		alert("Caution: NUMMDL=" + nummdl + " but REMARK 210: " +
			"CONFORMERS SUBMITTED=" + confsub +
			"\nNUMMDL will be reported.");
	}

	modelCount = nummdl;
	if (nummdl == -1)
		modelCount = confsub;

	if (modelCount != -1)
	{
		igot = ": &nbsp; <b>" + modelCount + "</b> Model";
		if (modelCount > 1)
			igot += "s:";
		else
			igot += "."
	}
	else if(match(expMethod, "nmr"))
		igot = ": &nbsp; Number of models <i>not found</i>.";

	if (modelCount > 1)
	{
		igot += " " +
			makeViewLink("allModelsSpt", ViewAllModels_txt, "makeAllModelsHelp()",
			AllModelsTT_txt) + ".";
	}

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function jgetfi(key)
{
	var igot = jmolGetPropertyAsString("fileInfo", key);

	// delete leading /fileInfo "/
	igot = igot.substring(igot.indexOf('\"') + 1);

	// delete double quotes
	igot = igot.replace(/\"/g, "");

//	igot = igot[0] + igot.substring(1).toLowerCase();


	// (per word)
//	igotw = igot.split(" ");
//	for (i = 0; i < igotw.length; i++)
//	{
//		igotw[i] = igotw[i].toLowerCase();
//	}

// replaces possible comma with space
//	igot = igotw.join();
//	igot = igot.replace(/,/g, " ");

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getresval()
{
	var resval = jgetfi("remark2");

	// delete newlines
	resval = resval.replace(/\\n/g, "");

	// delete all letters and spaces
	resval = resval.replace(/[A-Z ]/g, "");

	// delete first and last characters which are periods
	resval = resval.substring(1).substring(0, resval.length - 2);

	resfloat = parseFloat(resval);

	return resval;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getMissingCount() // also gets missingPerChainInfo[][]
{
	var mcount = 0;

	var itrim, atchain, oldchain, ichain, perchain;
	// first and last sequence numbers for each missing seq-consecutive segment.
	var isegment; // index to missing segment in current chain
	var firstseq = new Array();
	var lastseq = new Array();
	var firstins = new Array();
	var lastins = new Array();
	var missneg = 0; // charged residues per chain
	var misspos = 0; // charged residues per chain
	var atseq;
	var atins; // insertion code
	var atline;
	var prevseq = 0; // sequence numbers
	var previns; // insertion code
	var conseq; // insertion code
	var prevseqSet = false;

	missingNeg = 0;
	missingPos = 0;

	var igot = jgetfi("remark465");	
//	alert("|" + igot + "|");

	if (igot.length > 0)
	{
		keymiss = "SSSEQI\\n"; // N.B. includes NEWLINE

		// trim off the table header and leading newline
		itrim = igot.substring(igot.indexOf(keymiss) + keymiss.length);

		perchain = 0; // count in current chain
		ichain = 0; // index of current chain
		atchain = oldchain = ""; // name of current and previous chain

		isegment = 0; // index of current seq-consecutive missing segment per chain.
		missneg = 0; // missing charged residues
		misspos = 0;

		// GATHER missingPerChainInfo[][]
		// while we have a missing residue
		while((inl = itrim.indexOf("\\n")) != -1)
		{
			// Examples (no leading spaces)
			//    "ASP A   533"  =  "ASP A   533"
			//    "DT A   533"   -> " DT A   533"
			//    "U A   533"    -> "  U A   533"
			// Example with INSERTION CODE
			//                      "SER C   178G"

			// Insert leading spaces for DNA/RNA so columns line up
			if (itrim.charAt(2) == " ")
			{
				itrim = " " + itrim; // DNA
				inl += 1;				
			}
			else if (itrim.charAt(1) == " ")
			{
				itrim = "  " + itrim; // RNA
				inl += 2;				
			}

//			if (itrim.charAt(0) == " ")
//				alert ("moltab.js #15 itrim:\n" + itrim);

			// get chain
			atchain = itrim.charAt(4);
//			alert("moltab.js #11 atchain=" + atchain);

			// get the current sequence number
			atseq = parseInt(itrim.substring(5, inl)); // insertion code ignored

			// get the current insertion code if any (4dqo)
			atins = itrim.charAt(11); // either a letter or "\" from "\n"
			if (atins == "\\")
				atins = "";

//			if (atins != "")
//				alert("moltab.js #17 atins not blank=" + atins);

//			if (atins == "A" || atins == "Q" || atins == "N")
//				alert("moltab.js #16 atins=" + atins);

			if (atchain != oldchain) // true if this is the first chain
			{
				// record the old chain
				if (oldchain.length > 0) // false if this is the first chain
				{
					// record chain name
//					alert("moltab.js #11b ichain=" + ichain + " oldchain=" + oldchain +
//						" perchain=" + perchain);
					missingPerChainInfo[ichain][0] = oldchain;

					// record total missing residues in this chain
					missingPerChainInfo[ichain][1] = perchain;

					missingPerChainInfo[ichain][2] = missneg;
					missingPerChainInfo[ichain][3] = misspos;
					missingNeg += missneg;
					missingPos += misspos;

					// bump isegment so it is the count of segments
					isegment++

					// for each missing segment in the the old chain
					for (var ims = 0; ims < isegment; ims++)
					{
						missingPerChainInfo[ichain][4 + (mStep * ims)] = firstseq[ims];
						missingPerChainInfo[ichain][5 + (mStep * ims)] = firstins[ims];
						missingPerChainInfo[ichain][6 + (mStep * ims)] = lastseq[ims];
						missingPerChainInfo[ichain][7 + (mStep * ims)] = lastins[ims];
					}
				}

				// start a new chain
				if (oldchain.length > 0)
					ichain++;
				isegment = 0;
				firstseq[isegment] = atseq;
				firstins[isegment] = atins;
				missneg = 0;
				misspos = 0;

				perchain = 0;

			} // end of atchain != oldchain

			// IF/ELSE: PUT NO CODE HERE!

			// chain has not changed:
			// if atseq is not consecutive with prevseq
			else if (prevseqSet)
			{
				// is atseq consecutive to prevseq? (178 to 179) or (178 to 178A) or
				//   (178F to 178G)
				conseq = (atseq == (prevseq + 1)) ||
					(atseq == prevseq && atins != previns);

//			alert("moltab.js #18 conseq=" + conseq + "\n" +
//				"atseq=" + atseq + " prevseq=" + prevseq + "\n" +
//				"atins=" + atins + " previns=" + previns);

				if (!conseq)
				{
//				alert("moltab.js #11d atseq != prevseq + 1");

					// record old missing segment
					// old firstseq recorded above
					lastseq[isegment] = prevseq;
					lastins[isegment] = previns;

					// start new missing segment
					isegment++;
					firstseq[isegment] = atseq;
					firstins[isegment] = atins;
				} // end of !conseq
			} // end of prefseqSet

			// Now that a new chain has been started if appropriate,
			// (and we are not in the middle of an if/else!)
			// count missing charged residues in THIS chain
			atline = itrim.substring(0, inl);
			if (match(atline, "GLU") || match(atline, "ASP"))
				missneg++;
			if (match(atline, "ARG") || match(atline, "LYS"))
				misspos++;

			perchain++;
			oldchain = atchain;

//			alert("moltab.js #11c atseq=" + atseq + " prevseq=" + prevseq +
//				" isegment=" + isegment);

			prevseq = atseq;
			previns = atins;
			prevseqSet = true; // to mark the first time it is set

			// set lastseq tentatively, in case next missing is a different chain
//			alert("moltab.js #19 setting lastseq[" + isegment + "]=" + prevseq);			
			lastseq[isegment] = prevseq; 
			lastins[isegment] = previns; 

			mcount++;
			itrim = itrim.substring(inl + 2);

		} // end of while there is a missing residue

		// no more missing residues
		// record the final chain

		// record chain name
//		alert("moltab.js #11a ichain=" + ichain + " oldchain=" + oldchain +
//			" perchain=" + perchain);

		missingPerChainInfo[ichain][0] = oldchain;

		// record total missing residues in this chain
		missingPerChainInfo[ichain][1] = perchain;

		// record missing charges
		missingPerChainInfo[ichain][2] = missneg;
		missingPerChainInfo[ichain][3] = misspos;

		missingNeg += missneg;
		missingPos += misspos;

		// record lastseq
		lastseq[isegment] = atseq;
		lastins[isegment] = atins;

		// make isegment the count of missing segments in this chain
//		alert("moltab.js #12a isegment=" + isegment);
		isegment++;

		// for each missing segment in the the old chain
		for (var ims = 0; ims < isegment; ims++)
		{
			missingPerChainInfo[ichain][4 + (mStep * ims)] = firstseq[ims];
			missingPerChainInfo[ichain][5 + (mStep * ims)] = firstins[ims];
			missingPerChainInfo[ichain][6 + (mStep * ims)] = lastseq[ims];
			missingPerChainInfo[ichain][7 + (mStep * ims)] = lastins[ims];
		}
	} // end of 'if remark 465 exists'

//	alert("moltab.js #12 missingPerChainInfo:\n" + 
//		"[0].length=" + missingPerChainInfo[0].length + "\n" +
//		"length=" + missingPerChainInfo.length + "\n" +
//		missingPerChainInfo);

	missingCount = mcount; // total missing for all chains

	// MAKE LINK FOR MISSING RESIDUE COUNT
	if (mcount > 0)
	{
		igot = "<b><font color='magenta'>" + mcount +
			"</font></b> <a href='javascript: showMissingReport()' " +
			"title='List Missing Residues'>Missing Residues</a>";

		if ( (parseInt(missingNeg) + parseInt(missingPos)) > 0)
		{
			igot += " including ";
			if (parseInt(missingNeg) > 0)
				igot += "<font color='red'>" + missingNeg + "-</font>";
			if ( (parseInt(missingNeg) > 0) && (parseInt(missingPos) > 0) )
				igot += ", ";
			if (parseInt(missingPos) > 0)
				igot += "<font color='blue'>" + missingPos + "+</font>";
			igot += " charged amino acids";
		}
		igot += "!";
	}
	else
		igot = "<a href='javascript: showMissingReport()' " +
		"title='" + ClickForExplanation_TT +
		"'>No Missing Residues.</a>";

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showMissingReport()
{
	cancelPendingAndShowHelp("makeMissingReport()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeMissingReport()
{
	var missmsg =
'<b>' + missingCount + ' Missing Residues</b>\n';

	if (missingCount > 0)
	{
		missmsg +=
'<table width="88" border="0" align="right"><tr><td> \n\
<img src="empty-basket.png"> \n\
</td><td> \n\
Empty basket at missing residue(s). \n\
</td></tr></table> \n\
';
	}

	missmsg += '<br><br> \n';

	if (missingCount > 0)
	{
		missmsg +=
'<form name="missing"><input type="checkbox" name="markBroken" \n\
onClick="toggleMarkBroken()" '

+ (markBrokenEnds?"checked":"") +

'>Mark &quot;broken ends&quot; adjacent to missing residues \
with &quot;empty baskets&quot;.</form>\
<br clear="right"><br>';
	}

	// tabular report
	missmsg += makeMissingByChainReport() + '<br>';

	if (missingCount == 0)
		missmsg += "<br>";

	if (match(expMethod, "nmr"))
		missmsg +=
'Most models from \n\
<a href="http://proteopedia.org/wiki/index.php/NMR_Ensembles_of_Models" \n\
target="_blank">NMR studies</a> \n\
include all of the residues that were present in the experiment. \n\
Only 14%* of models from solution NMR experiments have missing residues. \n\
These are sometimes a histidine tag engineered into the \n\
chain to facilitate purification \n\
(<a href="fg.htm?mol=2m03" \n\
target="_blank">2m03</a>, \n\
<a href="fg.htm?mol=2lcs" \n\
target="_blank">2lcs</a>, \n\
<a href="fg.htm?mol=1ibx" \n\
target="_blank">1ibx</a>). \n\
\
In other cases, the ends of chains are omitted from the model, \n\
perhaps due to insufficient restraint data for these residues \n\
(<a href="fg.htm?mol=2lex" \n\
target="_blank">2lex</a>, \n\
<a href="fg.htm?mol=2m14" \n\
target="_blank">2m14</a>, \n\
<a href="fg.htm?mol=4asw" \n\
target="_blank">4asw</a>). \n\
\
<br><br> \n\
In X-ray crystallography, \n\
<a href="http://proteopedia.org/w/Temperature_value" \n\
target="_blank">disorder</a> ';

	else missmsg +=
'<a href="http://proteopedia.org/w/Temperature_value" \n\
target="_blank">Disorder</a> ';


	missmsg += 
'in local regions of the crystal used for \n\
<a href="http://proteopedia.org/w/X-ray_crystallography" \n\
target="_blank">X-ray diffraction</a> \n\
makes it impossible to determine the positions \n\
of some residues in 77%* of cases. This is because disorder makes the \n\
<a href="http://proteopedia.org/w/Electron_density_map" \n\
target="_blank">electron density map</a> \n\
for those residues \n\
too blurry. \n\
Such residues were present in the crystallized molecule, but \n\
are absent in the molecular model. \n\
In less extreme cases, the sidechain of an amino acid may be missing \n\
due to disorder, but the main chain atoms are present in the model \n\
(see \n\
<a href="notes.htm#icsc" \n\
target="_blank">incomplete sidechains).</a> \n\
\
<br><br> \n\
Often the portions of a protein that are disordered in a crystal, \n\
and hence missing from the model, are \n\
<a href="http://proteopedia.org/w/Intrinsically_Disordered_Protein" \n\
target="_blank">intrinsically disordered (natively unfolded)</a>. \n\
High charge density is a major \n\
factor contributing to intrinsic disorder. \n\
See <i>Predict intrinsically disordered regions</i> under the '

+ tab3Name_txt +

' Tab.';

	missmsg +=
'<br><br>Missing residues are listed in REMARK 465 of the PDB file.';

	if (missingCount >0)
		missmsg +=
' Below they are colored according to charge: \n\
<font color="#3030ff">positive ARG LYS</font> and \n\
<font color="#8080ff">HIS</font> (pKa 6.0), and \n\
<font color="red">negative ASP GLU</font>. \n\
<font color="#8080ff">HIS</font> is not counted in the above table. \n\
';
	else
		missmsg += " In this case, REMARK 465 is absent.\n";

	var misstech =
'*Percentages above were determined for 78,162 X-ray entries, \n\
and 9,812 NMR entries in the PDB on March 10, 2013.';

	var igot = jgetfi("remark465");

	if (igot.length > 0)
	{

		igot = igot.replace(/\\n/g, "<br>");

// 4asw NMR
//REMARK 465 SSSEQ=SEQUENCE NUMBER; I=INSERTION CODE.)                            
//REMARK 465   MODELS 1-  9                                                       
//REMARK 465     RES C SSSEQI                                                     
//REMARK 465     MET A     1                                                      

// 1o9a NMR; 1d66 XRAY
//REMARK 465 IDENTIFIER; SSSEQ=SEQUENCE NUMBER; I=INSERTION CODE.)                
//REMARK 465                                                                      
//REMARK 465   M RES C SSSEQI                                                     
//REMARK 465     XXX X     1                                                      

// Therefore prepend "M " when header line does not begin with "M ".

		var mhead, mlist;

		// tidy up missing M (Model column) see above cases
		var keymiss = "M RES C SSSEQI";
		var ihead = igot.indexOf(keymiss)
		if (ihead == -1)
		{
			keymiss = "RES C SSSEQI";
			ihead = igot.indexOf(keymiss)
			if (ihead != -1)
			{
				mhead = igot.substring(0, ihead);
				mhead = mhead + "M RES C SSSEQI";
			}
		}
		else
			mhead = igot.substring(0, ihead + keymiss.length);

		mhead += "<br>";

		// + 4 to exclude leading <br>
		mlist = igot.substring(ihead + keymiss.length + 4);

		mlist = formatMissingList(mlist); // do 1st
		mlist = colorMissingListCharges(mlist); // do 2nd; inserts blank lines
			// between chains

		igot = mhead + mlist;

		// delete leading <br>
		if (igot.substring(0, 4) == "<br>")
			igot = igot.substring(4);
	}
	
	igot = missmsg + "<pre>" + igot + "</pre>" + misstech;

	// comment out for public release
//	igot += brokenEndsReport; // returns report for dev/debug only

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function toggleMarkBroken()
{
	markBrokenEnds = !markBrokenEnds;
	doMolViewSpt("");
//	alert("moltab.js #24 markBrokenEnds=" + markBrokenEnds);
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function formatMissingList(mlist)
{
		// loop thru lines prepending 1/2 more spaces for DNA/RNA.
		var fixedlines = "";
		oldIDelim = 0;
		var aline;
		while ((aline = getLine(mlist, "<br>")) != "")
		{
			if (aline.charAt(1) == " ") // RNA "U "
				aline = "  " + aline;
			else if (aline.charAt(2) == " ") // DNA "DT "
				aline = " " + aline;

			// prepend 2 spaces before each residue
			aline = "  " + aline;

			fixedlines += aline;
		}
		mlist = fixedlines;

		return (mlist);
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function colorMissingListCharges(mlist)
{
		// loop thru lines adding charge colors
		var fixedlines = "";
		oldIDelim = 0;
		var aline;
		var aa, cn, oldcn, addbr;
		oldcn = "";
		while ((aline = getLine(mlist, "<br>")) != "")
		{
//			if (oldIDelim < 50) alert (aline);

			addbr = false;
			cn = aline.charAt(6);
//			alert("moltab.js #20 cn=" + cn + " aline:\n" + aline);
			if (oldcn != "" && cn != oldcn)
			{
				addbr = true;
//			alert("moltab.js #20 cn=" + cn + " oldcn=" + oldcn);
			}
			oldcn = cn;

			// 2 spaces have been prepended in formatMissingList()
			aa = aline.substring(2, 5);
			if (aa == "GLU" || aa == "ASP")
				aline = "  <font color='red'>" + aa + "</font>" + aline.substring(5);
			if (aa == "ARG" || aa == "LYS")
				aline = "  <font color='#3030ff'>" + aa + "</font>" + aline.substring(5);
			if (aa == "HIS")
				aline = "  <font color='#8080ff'>" + aa + "</font>" + aline.substring(5);

			if (addbr)
				aline = "<br>" + aline;

			fixedlines += aline;
		}
		mlist = fixedlines;

		return mlist;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
var oldIDelim = 0;

function getLine(txt, delim)
{
	var iDelim = txt.indexOf(delim, oldIDelim + 1);
	if (iDelim == -1)
	{
		oldIDelim = 0;
		return "";
	}

	var istart = oldIDelim + delim.length;
	if (oldIDelim == 0)
		istart = 0;	
	var aline = txt.substring(istart, iDelim + delim.length);
	oldIDelim = iDelim;
	return aline;	
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeMissingByChainReport()
{
	if (missingCount == 0)
	{
		var nomiss;
		if (validPDBId.length == 4)
			nomiss = "<b>No</b> residues are missing in " + validPDBId + ".";
		else
			nomiss = "<b>No</b> residues are missing.";

		return nomiss;
	}

	var bcm = "<center><b>Summary By Chain</b></center>";

	var mpcinam;
	var impci = 0;

	var cnam;

	var chainBox = new Array(); // seqID chains with identical missing
	var boxCount;
	var chainBoxMissingI = new Array();

	var msegstart, msegend, msegstartins, msegendins;

	// HEADER FOR ENTIRE TABLE
	bcm += "<center><table cellpadding='2'><tr>" +
		"<td>Chain(s)</td>" +
		"<td>Missing<br>Residues</td>" +
		"<td>Missing<br>Charges</td>" +
		"<td>Segment Ranges</td></tr>";

	// FOR EACH GROUP OF SEQUENCE IDENTICAL CHAINS
	for (var icg = 0; icg < chainList.length; icg++) // group of seqID chains
	{
		chainBox.length = 0; // restart array for each group
		boxCount = 0;
		chainZeroMissingBox = "";

		// GATHER CHAINS INTO GROUPS WITH IDENTICAL MISSING INFO
		for (var ic = 0; ic < chainList[icg].length; ic++) // each chain in group
		{
			cnam = chainList[icg][ic];
			impci = findChainIndex(cnam); // returns -1 when none missing

			if (impci == -1)
			{
				chainZeroMissingBox += cnam;
			}
			else // there are missing residues in this chain
			{
				if (ic == 0) // start first box
				{
					chainBox[boxCount] = cnam;
					chainBoxMissingI[boxCount] = impci;
					boxCount++; // count of occupied boxes
				}
				else // put in matching box or start new box
				{
					var oldbox = -1;
	
					// for each box already populated, does new chain fit?
					for (box = 0; box < chainBox.length; box++)
					{
						if (missingPerChainInfo[impci].length == // current chain
							missingPerChainInfo[chainBoxMissingI[box]].length) // box chain
						// same length so we can do a loop thru lengths
						{
							// start at 1 skipping chain name!
							var idcount = 0;
							for (ii = 1; ii < missingPerChainInfo[impci].length; ii++)
							{
								if (missingPerChainInfo[impci][ii] ==
									missingPerChainInfo[chainBoxMissingI[box]][ii])
									idcount++;
							}
							idcount++; // add 1 for chain
							if (idcount == missingPerChainInfo[impci].length)
								oldbox = box;
						}
					} // end loop for each box

					if (oldbox == -1) // start a new box
					{
						chainBox[boxCount] = cnam;
						chainBoxMissingI[boxCount] = impci;
						boxCount++;
					}
					else // put it in oldbox
					{
						chainBox[oldbox] += cnam;
					}

				} // end put in matching box or start new box
			} // end there are missing residues in this chain
		} // end each chain in seqID group

//		var alertme = 
//			"moltab.js #13 chainBox:\n" + chainBox + "\n" +
//			"chainBox.length=" + chainBox.length;
//		if (chainBox.length > 0)
//			alertme += 
//				"\nchainBox[0].length=" + chainBox[0].length;
//		alert(alertme);

		// REPORT THIS GROUP

		// CHAIN LENGTH & TYPE TABLE HEADER for this group
		var glength;
		var gtype;

		if (chainBox.length == 0) // no chain in this group has missing residues
			var lcnam = chainZeroMissingBox.charAt(0);
		else // Some (but perhaps not all) chains in this group have missing residues.
			lcnam = chainBox[0][0];

		glength = chainLengthFromName(lcnam);
		gtype = chainTypeFromName(lcnam);

		bcm += "<tr><td colspan='4' bgcolor='#d8d8d8'><center><b>" +
			glength +
			"</b> residues of " + gtype +
			":</center></td></tr>";

		// MISSING SEGMENTS ROW
		// No chains in this group have missing residues.
		if (chainBox.length == 0)
		{
			bcm += tabulateZeroMissing();
		}
		// Some (but perhaps not all) chains in this group have missing residues.
		else
		{
			for (var ibox = 0; ibox < chainBox.length; ibox++)
			{
				if (ibox == 0) // start new group -- tabulate zero missing
				{
					// TESTED OK with 1ucy, 3nn8
					//   (some but not all seqID chains have missing)
					// report chains with zero missing
					bcm += tabulateZeroMissing();

				} // end of start new group

				// make comma-delimited list of chains in this box
				var clist = "";
				for (var icl = 0; icl < chainBox[ibox].length; icl++)
				{
					if (icl > 0)
						clist += ",";
					if (icl > 0 && (icl % 5) == 0)
						clist += "<br>";
					else
						clist += " ";

					clist += chainBox[ibox].charAt(icl);
				}

				var impci = chainBoxMissingI[ibox];

				var segcount = (missingPerChainInfo[impci].length - 4)/mStep;

				var missneg = missingPerChainInfo[impci][2];
				var misspos = missingPerChainInfo[impci][3];

				bcm += "<tr><td>" + clist + "</td>" + // Chain
					"<td>" + missingPerChainInfo[impci][1] + "</td>" + // Missing Count
//					"<td>" + segcount + "</td>" + // Segment count
					"<td>";

				if ( (parseInt(missneg) + parseInt(misspos)) == 0)
				{
					// say 0 for protein, nothing for nucleic
					var ctype = chainTypeFromName(chainBox[ibox][0]);
					if (match(ctype, "DNA") || match(ctype, "RNA"))
						bcm += "&nbsp;";
					else
						bcm += "0";
				}
				else
				{
					if (parseInt(missneg) == 0)
						bcm += "0-";
					else
						bcm += "<font color='red'>" + missneg + "-</font>";

					bcm += ", ";

					if (parseInt(misspos) == 0)
						bcm += "0+";
					else
						bcm += "<font color='blue'>" + misspos + "+</font>";
				}
				bcm += "</td><td>";

				// list the sequence range for each missing segment
				for (var iseg = 0; iseg < segcount; iseg++)
				{
					if (iseg > 0)
						bcm += ", ";

					msegstart =    missingPerChainInfo[impci][4 + (mStep * iseg)];
					msegstartins = missingPerChainInfo[impci][5 + (mStep * iseg)];
					msegend =      missingPerChainInfo[impci][6 + (mStep * iseg)];
					msegendins =   missingPerChainInfo[impci][7 + (mStep * iseg)];

					if (parseInt(msegstart) < 0)
						msegstart = "(" + msegstart + msegstartins + ")";
					else
						msegstart += msegstartins;
					if (parseInt(msegend) < 0)
						msegend = "(" + msegend + msegendins + ")";
					else
						msegend += msegendins;

					bcm += msegstart + "-" + msegend;
						
				}
				bcm += "</td></tr>";

				impci++;
			} // end of some chains in this group have missing residues.
		} // end of this group
	} // end of all groups
	bcm += "</table></center>";

	return bcm;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function tabulateZeroMissing() // returns line of table
{
	var bcm = "";

	if (chainZeroMissingBox.length == 0)
		return bcm;

	// list chains with zero missing

	var zlist = "";
	for (var izl = 0; izl < chainZeroMissingBox.length; izl++)
	{
		if (izl > 0)
			zlist += ",";
		if (izl > 0 && (izl % 5) == 0)
			zlist += "<br>";
		else
			zlist += " ";

		zlist += chainZeroMissingBox.charAt(izl);
	}

	bcm += "<tr><td>" + zlist + "</td>" + // Zero Chains
		"<td>0</td>" + // Missing Count
		"<td>&nbsp;</td>" + // Segment count
		"<td>&nbsp;</td></tr>";

	return bcm;	
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function findChainIndex(cnam)
{
	var impci = 0;

	while((mpcinam = missingPerChainInfo[impci][0]) != "")
	{
		if (cnam == mpcinam)
			return impci;
		impci++;
	}
//	alert("Error in software: Cannot find	chain " + cnam +
//		"\n in missingPerChainInfo.");

	return (-1);
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
// A "broken end" is where some residues are missing.

function makeMarkBrokenEndsSpt()
{
	if (missingCount == 0)
	{
		markBrokenEndsSpt = "";
		return "";
	}

	var msegstart, msegend, msegstartins, msegendins;
	var minusone, plusone;
	var end1, end2, end1jmol, end2jmol;
	var ctype, resatom;
	var segcount;
	var selectbrokenends = "";

	// ber IS A DEVELOPMENT DEBUGGING REPORT NOT SHOWN IN RELEASED VERSIONS.
	var ber = "<br><br>";
	var spt =
'set labelgroup on;\n\
font label 20 sansserif bold;\n\
set labeloffset 0 0;\n\
color label black;\n\
initgapmesh();\n\
';

	var impci = 0;
	while((cnam = missingPerChainInfo[impci][0]).length > 0)
	{
			// cnam should == missingPerChainInfo[impci][0]
			ber += "Chain " + cnam + ": ";

			segcount = (missingPerChainInfo[impci].length - 4)/mStep;

			// for each missing segment in this chain
			for (var iseg = 0; iseg < segcount; iseg++)
			{
				if (iseg > 0)
						ber += ", ";

				msegstart =    missingPerChainInfo[impci][4 + (mStep * iseg)];
				msegstartins = missingPerChainInfo[impci][5 + (mStep * iseg)];
				msegend =      missingPerChainInfo[impci][6 + (mStep * iseg)];
				msegendins =   missingPerChainInfo[impci][7 + (mStep * iseg)];

				// for now I'm ignoring insertion codes e.g. 100^A:B

				ctype = chainTypeFromName(cnam);
				if (match(ctype, "protein"))
					ctype = "protein";
				else
					ctype = "nucleic";

				minusone = parseInt(msegstart) - 1;
				end1 = jmolAtomCount(minusone + ":" + cnam + " and " + ctype);
				if (end1 > 0)
					msegstart = "" + msegstart + "*";

				plusone = parseInt(msegend) + 1;
				end2 = jmolAtomCount(plusone + ":" + cnam + " and " + ctype);
				if (end2 > 0)
					msegend = "" + msegend + "*";

				ber += msegstart + msegstartins + " to " + msegend + msegendins;

				if (match(ctype, "protein"))
					resatom = "ca";
				else
					resatom = "c5'";

				end1jmol = minusone + ":" + cnam + "." + resatom;
				end2jmol = plusone + ":" + cnam + "." + resatom;

				// Cannot evaluate hidden here because ~hidden_jdef has not
				// yet been updated in Jmol. gapmesh() does it within Jmol
				// after the update.

				if (end1 > 0 && end2 > 0) // mesh spans 2 ends
				{
					spt += "gapmesh({" + end1jmol + "}.atomno, "
						+ "{" + end2jmol + "}.atomno);\n";
				}
				else if (end1 > 0)
					spt += "gapmesh({" + end1jmol + "}.atomno);\n";
				else if (end2 > 0)
					spt += "gapmesh({" + end2jmol + "}.atomno);\n";

//				else GENERATE WARNING UNABLE TO MARK @@@
				else
					alert(
'Warning: Missing residues ' 
+ msegstart + " to " + msegend + " in chain " + cnam +
'\nare not marked with an empty basket.\n\
(Did not find nearby residues with coordinates.)');

				if (selectbrokenends.length > 0)
					selectbrokenends += ", ";
				selectbrokenends += end1jmol + ", " + end2jmol;
			}

			ber += "<br>";
			impci++;
	}

	selectbrokenends = "select " + selectbrokenends + ";";

	spt += selectbrokenends + "\n" + "define ~brokenends selected;";

//	alert("moltab.js #25 markBrokenEndsSpt:\n" + spt);

	markBrokenEndsSpt = spt;

	return ber;	
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeClearMarkBrokenEndsSpt()
{
	var spt = "initgapmesh();\n";

	clearMarkBrokenEndsSpt = spt;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
var defineInitGapMeshFunction =

'\nfunction initgapmesh() \n\
{ \n\
	isosurface gm* delete; \n\
	surfnumber = 0; \n\
} \n\
';

// call formats:
// gapmesh({4:a.ca}.atomno)
// gapmesh({484:a.ca}.atomno, {490:a.ca}.atomno)

// #COMMENTS IN THIS SCRIPT MUST END IN SEMICOLONS ELSE THEY
// COMMENT OUT THE SUBSEQUENT LINE OF CODE!

// a good example for gapradius is 4b14

var defineGapMeshFunction =

'function gapmesh(an1, an2) \n\
{ \n\
	surfnumber++; \n\
	var surfid = "gm" + surfnumber; \n\
\
	if (an2.length != 0) \n\
	{ \n\
		# if at least one of (an1, an2) is not hidden; \n\
		if ({atomno=an1 and !~hidden_jdef}.count > 0 || \n\
			{atomno=an2 and !~hidden_jdef}.count > 0) \n\
		{ \n\
			~gapradius = ({atomno=an1}.xyz.distance({atomno=an2}.xyz))/2; \n\
			~meshres = 0.7; \n\
			if (~gapradius > 4) {~meshres = 0.5;} \n\
			if (~gapradius > 8) {~meshres = 0.4;} \n\
\
			isosurface ID @surfid center (atomno=an1,atomno=an2) resolution @~meshres sphere @~gapradius mesh nofill; \n\
\
			#NOGO: color isosurface {atomno=an1}.color; \n\
			~gmcolor = {atomno=an1}.color; \n\
			color isosurface @~gmcolor; \n\
		} \n\
	} \n\
	else \n\
	{ \n\
		# if an1 is not hidden; \n\
		if ({atomno=an1 and !~hidden_jdef}.count > 0) \n\
		{ \n\
			isosurface ID @surfid center (atomno=an1) resolution 0.7 sphere 3 mesh nofill; \n\
			~gmcolor = {atomno=an1}.color; \n\
			color isosurface @~gmcolor; \n\
		} \n\
	} \n\
} \n\
';

/*
			if (~gapradius > 4) ~meshres = 0.5; \n\

*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function gradeFreeR()
{
	var igot = "";

	if (isNaN(rfreefloat))
		return igot;

	if (resfloat >= 1.0 && resfloat <= 4.0)
	{
		// Round resolution to nearest tenth, using 10x resolution value.
		// For example: 2.45 is rounded to 2.5 and used as 25.
		// 25 - 10 = 15 gives the index into the freeR array.
		var xten = (resfloat * 10.) + 0.5;
		var iroundres = parseInt(xten - (((10 * xten)%10)/10));
		var froundres = parseFloat(iroundres/10.);
//		alert(froundres);

		var indexrf = iroundres - 10;

		// round values between 3.5 and 4.0 to one of those values
		if (indexrf == 26 || indexrf == 27)
			indexrf = 25; // resolution 3.5
		else if (indexrf >= 28 && indexrf <= 30)
			indexrf = 26; // resolution 4.0

//	alert("moltab.js #23: resfloat, rfreefloat: " +
//		resfloat + ", " + rfreefloat + "\n" +
//		"iroundres, indexrf: " + iroundres + ", " + indexrf);

		if (resfloat >= 1.0 && resfloat <= 3.5)
		{
			if (rFree[indexrf][0] != froundres)
				alert("ERROR #1 in gradeFreeR() in moltab.js!\n" +
					"resolution=" + resfloat + " but rFree[" + indexrf + "][0]=" +
					rFree[indexrf][0]);
		}

//		alert("moltab.js #23b rFree:\n" + rFree)

		var gq = rFree[indexrf][1];
		var md = rFree[indexrf][2];
		var bq = rFree[indexrf][3];

		var vg_g = gq - 0.02;
		var g_av = (gq + md)/2.;
		var av_f = (md + bq)/2.;
		var f_p = bq + 0.02;

//	alert(rfreefloat + " " + vg_g + " " + g_av + " " + av_f + " " + f_p);

		if (rfreefloat <= vg_g)
			igot += "<font color='#00d000'><i>MUCH BETTER THAN AVERAGE at this resolution</i></font>";
		else if (rfreefloat > vg_g && rfreefloat <= g_av)
			igot += "<font color='green'><i>BETTER THAN AVERAGE at this resolution</i></font>";
		else if (rfreefloat > g_av && rfreefloat <= av_f)
			igot += "AVERAGE at this resolution";
		else if (rfreefloat > av_f && rfreefloat <= f_p)
			igot += "<font color='#a8a800'>" +
				"<i>WORSE THAN AVERAGE at this resolution</i></font>";
		else if (rfreefloat > f_p)
			igot += "<font color='red'>" +
				"<i>UNRELIABLE</i></font>";
		else igot += "[ERROR]";

//		igot += "<span style='background: black; color: #ff4040;'>" +
//			"&nbsp;UNRELIABLE&nbsp;</span>";

	} // end resfloat 1.0-4.0

	// add help icon
	igot += ' <a href="javascript: showFreeRHelp()">' +
		'<img src="help-icon24.png" border="0" align="center"></a>';
	
	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showFreeRHelp()
{
	cancelPendingAndShowHelp("makeFreeRHelp()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeFreeRHelp()
{
	var igot =
'<b>Reliability</b><br><br> \n\
<a href="http://proteopedia.org/w/Free_R" \n\
target="_blank">Free R</a> is generally considered to be the best \n\
indicator of the overall reliability of the model \n\
<b>at the resolution obtained</b>. \n\
<a href="http://proteopedia.org/w/Resolution" \n\
target="_blank">(Resolution</a> \n\
limits the detail that is possible to see.) \n\
Free R estimates model-to-data \n\
<b>dis</b>agreement: high values signal the liklihood of significant \n\
errors in the model. Low values are consistent with the model being \n\
correct. For the reliability of local regions of the model, see \n\
<i>Local Uncertainty</i> (under the '

+ tab1Name_txt +

' Tab). \n\
\
<br><br> \n\
<i>FirstGlance in Jmol</i> grades free R values as follows: \n\
<ol> \n\
<li><font color="#00d000"><i>MUCH BETTER THAN AVERAGE</i></font> \n\
<li><font color="green"><i>BETTER THAN AVERAGE</i></font> \n\
<li>AVERAGE \n\
<li><font color="a8a800">WORSE THAN AVERAGE</font> \n\
<li><font color="red">UNRELIABLE</font> \n\
</ol> \n\
\
<a href="notes.htm#grading" \n\
target="_blank">Methods \n\
for assigning the above grades are described</a>. \n\
';

/*
Median values of free R in the \n\
<a href="http://proteopedia.org/w/Protein_Data_Bank" \n\
target="_blank">Protein Data Bank</a>, \n\
for a range of \n\
<a href="http://proteopedia.org/w/Resolution" \n\
target="_blank">resolutions</a>, \n\
are summarized in the article  \n\
*/

	igot += 
'See also the article <a href="http://proteopedia.org/w/Free_R" \n\
target="_blank">Free R in Proteopedia.Org</a>. \n\
';

	return igot;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getChains() // gathers info about chains and returns clickable
// list of chains
{
	var chainSeqs = new Array; // let it evaporate when this function ends

	var rawCompnd = jgetfi("compnd");
	var rawSource = jgetfi("source");
	var rawSeqres = jgetfi("seqres");

//	alert("moltab.js #22 rawSeqres.length=" + rawSeqres.length + "\n" +
//		"rawSeqres:\n" + rawSeqres);

	noSeqres = rawSeqres.length == 0;

	// there is no semicolon on the end of COMPND or SOURCE!
	// they need to end semicolon instead of \n
	if (rawCompnd.substring(rawCompnd.length - 2) == "\\n")
		rawCompnd = rawCompnd.substring(0, rawCompnd.length - 2);
	rawCompnd += ";";

	if (rawSource.substring(rawSource.length - 2) == "\\n")
		rawSource = rawSource.substring(0, rawSource.length - 2);
	rawSource += ";";


	rawCompnd = rawCompnd.replace(/\\n/g, "<br>");
	rawSource = rawSource.replace(/\\n/g, "<br>");
	rawSeqres = rawSeqres.replace(/\\n/g, "<br>");

//	alert("moltab.js #9b rawSeqres: " + rawSeqres);

	if (!noSeqres) //-  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
	{
	// GET CHAIN LENGTHS, TYPES. EACH chainLengths[] "D  66".
		var ibr = 0;
		var oldibr = 0;
		var seqbr = "<br>";
		var oldChain = "";
		var newChain = "";
		var ll = 0;
		var ss = 0;
		var iget;
		var clen;
		var cseq;
		var cseqlist = "";

		// GET LENGTHS FROM SEQRES
		while((ibr = rawSeqres.indexOf(seqbr, ibr)) != -1)
		{
			clen = rawSeqres.substring(oldibr, oldibr + 7); // "D 14"
	
			newChain = clen.charAt(0);
			if (newChain != oldChain) // true for first chain
			{
				chainLengths[ll] = clen;
				ll++;
			}

			if (newChain != oldChain && oldChain != "")
			{
				chainSeqs[ss] = trim_ends(cseqlist);
				cseqlist = "";
				ss++
			}

			cseq = rawSeqres.substring(oldibr + 7, ibr);
			cseqlist += cseq;
	
			oldChain = newChain;
			oldibr = ibr + seqbr.length;
			ibr++;
		}
		// finish last chainSeqs
		chainSeqs[ss] = trim_ends(cseqlist);
	
	//	alert("moltab.js #9 chainLengths: " + chainLengths);
	//	alert("moltab.js #9e chainSeqs:\n" + chainSeqs.join("|\n") + "|");

		// GET CHAIN TYPES
		var chainWords;
		for (ss = 0; ss < chainSeqs.length; ss++)
		{
			chainWords = singleSpace(chainSeqs[ss]).split(" ");

	//		alert("moltab.js #9f chainWords.length: " + chainWords.length);

			clen = parseInt(chainLengths[ss].substring(1));

			if (chainWords.length != clen)
				alert(myBad + "moltab.js #21: clen != chainWords.length\n" +
					"clen=" + clen + " chainWords.length=" + chainWords.length);

			chainTypes[ss] = getChainType(chainWords);
		}
//	alert("moltab.js #9g chainTypes:\n" + chainTypes.join("|\n") + "|");

	} // end !noSeqres -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  

	// PARSE COMPND, SOURCE
	splitCompnd = rawCompnd.split("MOL_ID:");
	splitSource = rawSource.split("MOL_ID:");
	// extract chains

	// chainCount, chainList, chainMolecules, chainLengths

	// skip blank first split so split 1 goes into array 0, etc.
	for (var ii = 0; ii < (splitCompnd.length - 1); ii++)
	{
		// GET MOLECULE
		chainMolecules[ii] = cutFromTo(splitCompnd[ii+1], "MOLECULE:", ";");
		chainMolecules[ii] = chainMolecules[ii].replace(/MOLECULE: /, "");

		// CHAIN NAMES
		var clist = cutFromTo(splitCompnd[ii+1], "CHAIN:", ";");
		clist = clist.replace(/CHAIN:/, "");
		clist = clist.replace(/,/g, "");
		clist = clist.replace(/\ /g, "");
		clist = clist.replace(/<br>/g, "");
		chainList[ii] = clist;

		// CHECK FOR LOWER CASE CHAIN NAMES
		var lowercc = clist.match(/[a-z]/);
		if (lowercc != null)
		{
			useLowerCaseChains = true;
			scriptToJmol("set chainCaseSensitive true;");
		}
//			alert("Lower case chain name:\n" + clist);
//		else
//			alert("No lower case chain names.");
	} // end splitCompnd loop

//	alert("moltab.js #26 chainList=\n" + chainList);

	// count chains
	chainCount = 0;
	distinctChainCount = 0;
	for (var ii = 0; ii < chainList.length; ii++)
	{
		chainCount += chainList[ii].length;
		distinctChainCount++;
	}

	return makeClickableChainList();

}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeClickableChainList()
{
	// GENERATE SHORT REPORT FOR TOP PANEL
	var linkhead = '<a href="javascript: haloChain(\'';
	var linktail1 = '\')" title="Put halos on chain ';
	var linktail2 = '">';

	var report = "";
	if (!match(expMethod, "nmr"))
	{
		report += "<li>Asymmetric unit:" +
			' <a href="javascript: showAUHelp()">' +
			'<img src="help-icon24.png" border="0" ' +
			'align="center"></a>';

		report += "<ul>";
	}

	report += "<li>";

	report += chainCount + " chains (" + distinctChainCount + " distinct): ";
	report += "<font color='gray'>";
	for (var ii = 0; ii < chainList.length; ii++)
	{
		if (ii > 0)
			report += ", ";
		if (chainList[ii].length > 1)
			report += "<b>" + chainList[ii].length + "</b>:";
		for (var jj = 0; jj < chainList[ii].length; jj++)
		{
			if (jj > 0)
				report += "=";
			if ((jj % 10) == 0)
				report += " "; // allow long lines to wrap
			report += linkhead + chainList[ii][jj] + linktail1 + 
				chainList[ii][jj] + linktail2 +
				chainList[ii][jj] + "</a>";
		}
	}
	report += "</font>";

	report += "</li><li>";

	report += '<a href="javascript: showChainDetails()" ' +
		'title="' + ChainDetailsTT_txt + '">' +
		ChainDetails_txt + '</a>.'

	report += ' &nbsp; <a href="javascript: showSequenceLinks()" ' +
		'title="' + SequencesTT_txt + '">' +
		Sequences_txt + '</a>.'

	report += "</li>";

	return report;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function makeChainDetails()
{
	chainDetails = "";

	for (var ii = 0; ii < chainList.length; ii++)
	{
		// HEADER FOR SEQ ID CHAINS
		if (chainList[ii].length > 1)
		{
			chainDetails += "<b>" + chainList[ii].length +
				"</b> Sequence-Identical Chains <b>";
						
			for (var jj = 0; jj < chainList[ii].length; jj++)
			{
				if (jj > 0)
					chainDetails += ", ";
				chainDetails += chainList[ii][jj];
			}
		}
		else
			chainDetails += "<b>Chain " + chainList[ii];

		chainDetails += ":</b><ul>"

		// REPORT MOLECULE
		chainDetails += "<li>" + chainMolecules[ii] + "</li>";

		// REPORT LENGTH
		if (noSeqres)
		{
			chainDetails += "<li>Chain length <i>not found</i>. (No SEQRES.)</li>"
		}
		else
		{
			var cc = chainList[ii].charAt(0);
			var cclen = chainLengthFromName(cc);
			chainDetails += "<li><b>" + cclen + "</b> residues";
		}

		// REPORT MISSING (chainList[ii] is the current list of seqID chains)
		if (missingCount > 0)
		{
			// I. GATHER MISSING RANGE FOR THIS GROUP OF SEQID CHAINS
			var cnam; // chain name
			var impci = 0; // index into missingPerChainInfo
			var iclist = 0; // index into clist (current group of seqID chains)
			var mpcmin = -1; // low  missing per chain count in seqID group
			var mpcmax = -1; // high missing per chain count in seqID group
			var mpccount;
			var missvary = false; // count missing per chain varies within group
				// of sequence-identical chains.
			var mpcinam;

			// for every chain in the current group of seqID chains (chainList[ii])
			for (var iclist = 0; iclist < chainList[ii].length; iclist++)
			{
				cnam = chainList[ii][iclist];
				chi  = -1;
				impci = 0; // there is at least one chain in missingPerChainInfo

				// find the matching chain (if it exists) missing count
				while((mpcinam = missingPerChainInfo[impci][0]) != "")
				{
					if (cnam == mpcinam)
					{
						mpccount = missingPerChainInfo[impci][1];

						// record min and max missing counts

						if (mpcmin == -1) // first count
							mpcmin = mpccount;
						else if (mpccount < mpcmin) // minimum
						{
							// save old minimum as maximum
							if (mpcmax == -1 || mpcmin > mpcmax)
								mpcmax = mpcmin;

							mpcmin = mpccount; // new minimum
						}

						// leave max at -1 unless it is > min
						if (mpccount > mpcmin && mpccount > mpcmax)
							mpcmax = mpccount;
					}
					impci++;
				} // end matching chain loop
			} // end chainList[ii] loop

			if (mpcmin == -1)
				chainDetails += " (none missing)"; // for one group of chains
			else
			{
				chainDetails += " (<font color='red'>" + mpcmin;
				if (mpcmax != -1)
					chainDetails += "</font> to <font color='red'>" + mpcmax;
				chainDetails += "</font> missing)";
			}
			
		} // end missing count > 0
		else
			chainDetails += " (none missing)"; // for every group of chains

		// REPORT TYPE
		if (noSeqres)
			chainDetails += ". Polymer type <i>not found</i>. (No SEQRES.)</li>";
		else
			chainDetails += " of " + chainTypes[ii] + ".</li>";

		// REPORT SOURCE
		//   SYNTHETIC?
		if (match(splitSource[ii+1], "SYNTHETIC: YES"))
			chainDetails += "<li>Synthetic.</li>";

		//   SPECIES
		var species = cutFromTo(splitSource[ii+1],
			"ORGANISM_SCIENTIFIC: ", ";");
		species = species.replace(/ORGANISM_SCIENTIFIC: /, "");
		species = capitalize(species);

		var spcom = cutFromTo(splitSource[ii+1],
			"ORGANISM_COMMON: ", ";");
		spcom = spcom.replace(/ORGANISM_COMMON: /, "");
		spcom = capitalize(spcom);

		if (species.length > 0)
		{
			chainDetails += "<li>Source: <i>" + species + "</i>";
			if (spcom.length > 0)
				chainDetails += " (" + spcom + ")";
			chainDetails += ".</li>";
		}

		// EXPRESSION_SYSTEM
		var expsys = cutFromTo(splitSource[ii+1],
			"EXPRESSION_SYSTEM: ", ";");
		if (expsys.length > 0)
		{
			expsys = capitalize(expsys);
			icolon = expsys.indexOf(":");
			expsys = setCharAt(expsys, icolon + 2,
				expsys.charAt(icolon + 2).toUpperCase());
			
			expsys = expsys.substring(0, icolon + 1).replace(/_/, " ") + "<i>" +
				expsys.substring(icolon + 1) + "</i>";

			chainDetails += "<li>" + expsys + ".</li>";
		}

		// OTHER_DETAILS
		var otherd = cutFromTo(splitSource[ii+1],
			"OTHER_DETAILS: ", ";");
		if (otherd.length > 0)
		{
			otherd = otherd.replace(/<br>/g, " ");
			otherd = capitalize(otherd);
			icolon = otherd.indexOf(":");
			otherd = setCharAt(otherd, icolon + 2,
				otherd.charAt(icolon + 2).toUpperCase());
			if (otherd.length > 0)
				chainDetails += "<li>" + otherd + ".</li>";
		}

		chainDetails += "</ul>";

	} // end chainList[ii] loop

	chainDetails +=
'The above information is extracted from the COMPND, SOURCE, \n\
and SEQRES records in the PDB file. Not all information in those \n\
records is shown above. To see the complete information, click the \n\
link <i>View PDB File</i> in the top panel above (under the '
+ molTabLabel +
' Tab).';

}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function chainLengthFromName(cnam)
{
		for (var icc = 0; icc < chainLengths.length; icc++)
		{
			if (cnam == chainLengths[icc].charAt(0))
			{
				return(parseInt(chainLengths[icc].substring(1)));
			}
		}	
	alert("Error in program #14: cannot find length of chain " + cnam);
	return -1;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function chainTypeFromName(cnam)
{
		for (var icc = 0; icc < chainLengths.length; icc++)
		{
			if (cnam == chainLengths[icc].charAt(0))
			{
				return(chainTypes[icc]);
			}
		}	
	alert("Error in program #14a: cannot find type of chain " + cnam);
	return "";
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showChainDetails()
{
	cancelPendingAndShowHelp("getChainDetails()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getChainDetails()
{
	return chainDetails;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showAUHelp()
{
	cancelPendingAndShowHelp("makeAUHelp()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showLigNSRHelp()
{
	cancelPendingAndShowHelp("makeLigNSRHelp()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*
function firstAndLastResNos()
{
	var chainInfo = jmolGetPropertyAsArray("chainInfo");
	var ilastres;

	var resnolist = "";

	// for model 0, loop thru chains
	for (icn = 0; icn < chainInfo.models[0].chains.length; icn++)
	{
		ilastres = chainInfo.models[0].chains[icn].residues.length - 1;

		// for model 0, each chain, get first and last residue
		resnolist += chainInfo.models[0].chains[icn].residues[0].seqCode +
		"-" + chainInfo.models[0].chains[icn].residues[ilastres].seqCode +
		"\n";
	}
	alert (resnolist);
}
*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*
function exploreChainInfo()
{
	var chainInfo = jmolGetPropertyAsArray("chainInfo");

	var cii = "chainInfo.models.length=" + chainInfo.models.length; // ALWAYS 1??

//	cii += "\n" + "ci.models.chains.length=" + ci.models.chains.length;
//	cii += "\n" + "ci.models[0].length=" + ci.models[0].length;

//	var cii = chainInfo.models[0].chains[0].residues[0].atomInfo1; // WORKS

//	var cii = chainInfo.models[0].chains[0].residues.length; // WORKS

//	var cii = chainInfo.models[0].chains.length; // WORKS
	
	alert (cii);

//		var chainInfoWin = window.open("");
//		with (chainInfoWin.document)
//		{
//			writeln("<pre>\n" + jmolGetPropertyAsArray("chainInfo") + "</pre>");
//		}

}
*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function showSequenceLinks()
{
	cancelPendingAndShowHelp("makeSequenceLinks()");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getUniProtID() // format: "A P04386" where A is the chain,
// for each chain in the array DBIds
{
	var DBIds = new Array();

	var DBRef = jgetfi("dbref");	

//DBREF  1D66 A    1    65  UNP    P04386   GAL4_YEAST       1     65
// Jmol returns only
//6 A    1    65  UNP    P04386   GAL4_YEAST       1     65

	// for each line in DBRef
	var inl, dbline;
	var dbw = new Array();
	var tnl = "\\n";
	var dbcount = 0;
	while ( (inl = DBRef.indexOf(tnl)) != -1)
	{
		dbline = DBRef.substring(0, inl);
		dbline = singleSpace(dbline);
		dbw = dbline.split(" ");
//		alert(dbw);
		if (dbw[4] == "UNP")
		{
			DBIds[dbcount] = dbw[1] + " " + dbw[5];
			dbcount++;
		}

		// trim off the processed line
		DBRef = DBRef.substring(inl + tnl.length);
	}

	return DBIds;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function areSequenceIdenticalChains(a, b)
{
	for (var icg = 0; icg < chainList.length; icg++)
	{
		if (match(chainList[icg], a) && match(chainList[icg], b) )
			return true;
	}
	return false;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getResidueCounts()
{
	alphaCarbonCount = jmolAtomCount("*.ca and protein");
	nonGlyAlphaCarbonCount = jmolAtomCount("*.ca and protein and not [gly]");
	betaCarbonCount = jmolAtomCount("*.cb and protein");
	mainChainNCount = jmolAtomCount("*.n and protein");
	mainChainOCount = jmolAtomCount("*.o and protein");
	c5primeCount = jmolAtomCount("*.c5' and nucleic");
	if (c5primeCount > 0)
	{
		c5primeDNACount = jmolAtomCount("*.c5' and dna");
		c5primeRNACount = jmolAtomCount("*.c5' and rna");
	}
	incompleteSidechainsProteinCount =
		jmolAtomCount("*.ca and protein and ~incomplete_sidechains");
	incompleteSidechainsNucleicCount =
		jmolAtomCount("*.c5' and nucleic and ~incomplete_sidechains");
	nucleicPhosphorusCount = jmolAtomCount("*.p and nucleic");
	dnaPhosphorusCount = jmolAtomCount("*.p and dna");
	rnaPhosphorusCount = jmolAtomCount("*.p and rna");

	var permodel = "";
	if (modelCount > 1)
		permodel = " per model";
	perModel = permodel;

	var rc = "";

	// PROTEIN

	if (alphaCarbonCount == 0)
		rc += "No amino acid alpha carbons.";
	else
	{
		// REPORT CA ONLY
		if (betaCarbonCount == 0)
		{
			rc += alphaCarbonCount +
				" <font color='red'>alpha-carbon only</font>" +
				" amino acids.";

			if (mainChainNCount > 0)
				rc += " (" + mainChainNCount + " main chain N atoms.)";
			else
				rc += " (No main chain nitrogens, no beta carbons.)";
		}
		else // SOME SIDECHAINS
		{
			rc += alphaCarbonCount + " amino acid alpha carbons" + permodel + ".";

			// MISSING BETA CARBONS (assume no AA's have beta without alpha)
			var noBeta = nonGlyAlphaCarbonCount - betaCarbonCount;
			if (noBeta > 0)
				rc += " <i>" + noBeta + " non-Glycines lack beta carbons.</i>";
			
			if (incompleteSidechainsProteinCount > 0)
			{
				var icscflt = (100 * incompleteSidechainsProteinCount) / alphaCarbonCount;
				var icscpct = parseInt(icscflt + 0.5);
//				alert("moltab.js #27 icscflt=" + icscflt + " icscpct=" + icscpct);

				rc += " " + incompleteSidechainsProteinCount +
				" (" + icscpct + "%) " +
				" have incomplete sidechains (marked <b>S-</b>).";
			}
			else
				rc += " (All sidechains complete.)";
		}
	}

	// NUCLEIC
	rc += "</li><li>";

	if (c5primeCount == 0)
	{
		if (nucleicPhosphorusCount == 0)
			rc += "No nucleic acids.";
		else
			rc += nucleicPhosphorusCount +
			" <font color='red'>phosphorus-only</font> nucleotides" +
			" (" + dnaPhosphorusCount + " DNA, " + rnaPhosphorusCount + " RNA).";
	}
	else
	{
		rc += c5primeCount + " nucleotide C5' atoms" + permodel +
			" (" + c5primeDNACount + " DNA, " + c5primeRNACount + " RNA).";

		if (incompleteSidechainsNucleicCount > 0)
			rc += " " + incompleteSidechainsNucleicCount +
				" have incomplete bases.";
//		else
//			rc += " (All bases appear complete.)";
	}
		
	return rc;		
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function getCharges()
{
	argCount = jmolAtomCount("[arg].ca");
	lysCount = jmolAtomCount("[lys].ca");
	hisCount = jmolAtomCount("[his].ca");
	gluCount = jmolAtomCount("[glu].ca");
	aspCount = jmolAtomCount("[asp].ca");
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
function putBottomControls(cpnum)
{
	var bc = '<span style="line-height:' + cpLineHeight + ';"><center>' +

	makeViewLink("hideSpt", Hide_txt + dd, "makeHideHelp()",
		HideTT_txt)
		+ " &nbsp; &nbsp; &nbsp; " +
	makeViewLink("makePreFindSpt()", Find_txt + dd, "makeFindHelp()",
		FindTT_txt);

	bc += "<br>" + makeBottomLinks() + makeLabelsCheckboxes(cpnum)
		+ "</center></span>";

	return bc;
}
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
